



alias -l ChangeBG {
  window -Cdpk0 +t @Select -1 -1 250 300
  titlebar @Select your background
  DrawBackground @Select
  drawtext -nohr @Select $rgb(255,255,255) "Times New Roman" 18 $int($calc(((250/2)-($width(Select Background,Times New Roman,18,1,0) / 2)) - 5)) 10 Select Background
  DrawRadio @Select 83 47 10 10
  drawpic @Select 98 30 [ %Calendar.directory $+ bg1_sml.bmp ]
  DrawRadio @Select 83 97 10 10
  drawpic @Select 98 80 [ %Calendar.directory $+ bg2_sml.bmp ]
  DrawRadio @Select 83 147 10 10
  drawpic -ns @Select 98 130 48 48 [ %Calendar.directory $+ bg3_sml.bmp ]
  DrawButton @Select 10 181 57 25 Other...
  EditBox @Select 70 184 165 20 None Selected
  DrawButton @Select 35 230 85 25 Select
  DrawButton @Select 125 230 85 25 Cancel
  drawdot @Select
}

alias -l CreditTitleFade.1 {
  drawtext -r @Credits $rgb($1,$2,$3) "Times New Roman" 30 $int($calc(145 - ($width($hget(CreditNames, Title1),Times New Roman,30,0,0) / 2))) $int($calc(85 - ($height($hget(CreditNames, Title1),Times New Roman,30) / 2))) $hget(CreditNames, Title1)
  if ($calc($1 + 5) < 255) { .timerCreditTitleFade -m 1 50 CreditTitleFade.1 $calc($1 + 5) $calc($2 + 5) $calc($3 + 5) }
  else { .timerCreditTitleFade -m 1 250 CreditTitleFade.2 255 255 255 }
}

alias -l CreditTitleFade.2 {
  drawtext -r @Credits $rgb($1,$2,$3) "Times New Roman" 30 $int($calc(145 - ($width($hget(CreditNames, Title1),Times New Roman,30,0,0) / 2))) $int($calc(85 - ($height($hget(CreditNames, Title1),Times New Roman,30) / 2))) $hget(CreditNames, Title1)
  if ($calc($1 - 5) > 0) { .timerCreditTitleFade -m 1 50 CreditTitleFade.2 $calc($1 - 5) $calc($2 - 5) $calc($3 - 5) }
  else { .timerCreditAnimate1 -m 1 250 CreditAnimate1 1 0 0 0 }
}

alias -l CreditAnimate1 {
  if ($1 == 1) { drawrect -rf @Credits $rgb(0,0,0) 1 0 0 300 200 | CreditTitleFade 0 0 0 Created By }
  elseif ($1 == 2) { drawrect -rf @Credits $rgb(0,0,0) 1 0 0 300 200 | CreditTitleFade 0 0 0 Beta Testers }
  elseif ($1 < 9) { drawtext -r @Credits $rgb(92,153,255) "Times New Roman" 24 $int($calc(145 - ($width(Beta Testers,Times New Roman,24,0,0) / 2))) 5 Beta Testers }
  .timerCreditFadeNamesIn -m 1 100 CreditFadeNamesIn $1 0 0 0
}

alias -l CreditFadeNamesIn {
  drawtext -r @Credits $rgb($2,$3,$4) "Times New Roman" 18 $int($calc(145 - ($width($hget(CreditNames, Name [ $+ [ $1 ] ] ),Times New Roman,18,0,0) / 2))) $int($calc(84 - ($height($hget(CreditNames, Name [ $+ [ $1 ] ] ),Times New Roman,18) / 2))) $hget(CreditNames, Name [ $+ [ $1 ] ] )
  if ($calc($2 + 8) > 255) { .timerCreditFadeNamesOut -m 1 100 CreditFadeNamesOut $1 255 255 255 }
  else { .timerCreditFadeNamesIn -m 1 50 CreditFadeNamesIn $1 $calc($2 + 8) $calc($3 + 8) $calc($4 + 8) }
}

alias -l CreditFadeNamesOut {
  drawtext -r @Credits $rgb($2,$3,$4) "Times New Roman" 18 $int($calc(145 - ($width($hget(CreditNames, Name [ $+ [ $1 ] ] ),Times New Roman,18,0,0) / 2))) $int($calc(84 - ($height($hget(CreditNames, Name [ $+ [ $1 ] ] ),Times New Roman,18) / 2))) $hget(CreditNames, Name [ $+ [ $1 ] ] )
  if ($calc($2 - 8) < 0) {
    if ($calc($1 + 1) > 8) { .timerCreditAnimate1 -m 1 50 CreditAnimate1 1 }
    else { .timerCreditAnimate1 -m 1 50 CreditAnimate1 $calc($1 + 1) } 
  }
  else { .timerCreditFadeNamesOut -m 1 50 CreditFadeNamesOut $1 $calc($2 - 8) $calc($3 - 8) $calc($4 - 8) }
}

alias -l CreditTitleFade {
  var %CalCredit.ctr $1
  var %CalCredit.ctg $2
  var %CalCredit.ctb $3
  drawtext -r @Credits $rgb($1,$2,$3) "Times New Roman" 24 $int($calc(145 - ($width($4-,Times New Roman,24,0,0) / 2))) 5 $4-
  if (%CalCredit.ctr <= 92) { inc %CalCredit.ctr 6 }
  if (%CalCredit.ctg <= 153) { inc %CalCredit.ctg 6 }
  if (%CalCredit.ctb <= 255) { inc %CalCredit.ctb 6 }
  if (%CalCredit.ctb <= 255) { .timerCreditTitleFade -m 1 50 CreditTitleFade %CalCredit.ctr %CalCredit.ctg %CalCredit.ctb $4- }
}

alias -l CreditWindowClose {
  .timerCredit* off
  var %CalCredit.ww 300
  var %CalCredit.wh 200
  var %CalCredit.shrinkcounter 1
  var %CalCredit.scrollcounter 1
  :ShrinkLoop
  window -dopCk0 +l @Credits -1 -1 %CalCredit.ww %CalCredit.wh
  if (%CalCredit.scrollcounter == 1) { drawscroll @Credits -1 0 0 0 %CalCredit.ww %CalCredit.wh }
  if (%CalCredit.wh > 15) {
    if (%CalCredit.scrollcounter == 2) { var %CalCredit.scrollcounter 1 }
    else { inc %CalCredit.scrollcounter }
    if (%CalCredit.shrinkcounter < 3) { dec %CalCredit.wh | inc %CalCredit.shrinkcounter }
    else { var %CalCredit.shrinkcounter 1 }
  }
  if (%CalCredit.ww > 15) { dec %CalCredit.ww | goto ShrinkLoop }
  else { window -c @Credits }
}

; ---------------------------------------
; The Install Screen for Calendar.
; Lets the user set the directory and
; choose background colors. Foreground
; Is automatically set.
; ---------------------------------------

alias -l UnInstallGUI {
  window -Cdpk0 +lt @UnInstall -1 -1 300 142
  drawrect -rf @UnInstall $rgb(0,0,0) 1 0 0 300 142
  titlebar @UnInstall Calendar v1.01
  drawtext -ohr @UnInstall $rgb(255,255,255) "Times New Roman" 18 $int($calc(150 - ($width(Uninstall Calendar,Times New Roman,18,1,1) / 2))) 10 Uninstall Calendar
  DrawRadio @UnInstall 30 48 10 10
  drawtext -rh @UnInstall $rgb(255,255,255) "Times New Roman" 14 50 45 Remove %Calendar.directory
  set %CUnInstall.currentdir $true
  set %CUnInstall.doinstall yes
  set %CUnInstall.stepnum 1
  DrawButton @UnInstall 57 82 85 30 Uninstall
  DrawButton @UnInstall 152 82 85 30 Cancel
}

alias UnInstallGUI3 {
  clear @UnInstall
  drawrect -rf @UnInstall $rgb(0,0,0) 1 0 0 300 142
  .timerDrawInstall -m 1 50 CUninstall.DropDownLines 0
}

alias -l CUninstall.DropDownLines {
  drawline -nr @UnInstall $rgb(0,255,0) 1 10 0 10 $1
  drawline -nr @UnInstall $rgb(0,255,0) 1 280 0 280 $1
  drawdot @UnInstall
  if ($1 < 70) { .timerCUninstall.DropDownLines -m 1 10 CUninstall.DropDownLines $calc($1 + 2) }
  else { .timerCUninstall.AcrossLines -m 1 10 CUninstall.AcrossLines 10 280 }
}

alias -l CUninstall.AcrossLines {
  drawline -nr @UnInstall $rgb(0,255,0) 1 280 70 $2 70
  drawline -nr @UnInstall $rgb(0,255,0) 1 10 70 $1 70
  drawdot @UnInstall
  if ($1 < 30) { .timerCUninstall.AcrossLines -m 1 10 CUninstall.AcrossLines $calc($1 + 2) $calc($2 - 2) }
  else { .timerDrawProgBox -m 1 10 CUninstall.DrawProgBox.1 70 70 }
}

alias -l CUninstall.DrawProgBox.1 {
  drawline -nr @UnInstall $rgb(0,255,0) 1 30 70 30 $1
  drawline -nr @UnInstall $rgb(0,255,0) 1 30 70 30 $2
  drawline -nr @UnInstall $rgb(0,255,0) 1 260 70 260 $1
  drawline -nr @UnInstall $rgb(0,255,0) 1 260 70 260 $2
  drawdot @UnInstall
  if ($1 > 60) { .timerDrawProgBox -m 1 10 CUninstall.DrawProgBox.1 $calc($1 - 2) $calc($2 + 2) }
  else { .timerDrawProgBox -m 1 10 CUninstall.DrawProgBox.2 30 260 | .timerDrawProgBoxLines 1 2 CUninstall.DrawProgBox.3 33 }
}

alias -l CUninstall.DrawProgBox.2 {
  drawline -nr @UnInstall $rgb(0,255,0) 1 30 60 $1 60
  drawline -nr @UnInstall $rgb(0,255,0) 1 30 80 $1 80
  drawline -nr @UnInstall $rgb(0,255,0) 1 260 60 $2 60
  drawline -nr @UnInstall $rgb(0,255,0) 1 260 80 $2 80
  drawdot @UnInstall
  if ($1 < 145) { .timerDrawProgBox -m 1 10 CUninstall.DrawProgBox.2 $calc($1 + 2) $calc($2 - 2) }
  else { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.1 60 }
}

alias -l CUninstall.DrawProgBox.3 {
  drawline -r @UnInstall $rgb(0,60,0) 1 $1 62 $1 79
  if ($1 < 258) { .timerDrawProgBoxLines -m 1 10 CUninstall.DrawProgBox.3 $calc($1 + 3) }
}

alias -l CUninstall.DrawPctBox.1 {
  drawline -nr @UnInstall $rgb(0,255,0) 1 145 60 145 $1
  drawdot @UnInstall
  if ($1 > 40) { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.1 $calc($1 - 2) }
  else { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.2 145 145 Bottom }
}

alias -l CUninstall.DrawPctBox.2 {
  if ($3 == Bottom) {
    drawline -nr @UnInstall $rgb(0,255,0) 1 145 40 $1 40
    drawline -nr @UnInstall $rgb(0,255,0) 1 145 40 $2 40
    drawdot @UnInstall
    if ($1 > 123) { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.2 $calc($1 - 2) $calc($2 + 2) Bottom }
    else { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.2 40 40 Sides }
  }
  elseif ($3 == Sides) {
    drawline -nr @UnInstall $rgb(0,255,0) 1 123 40 123 $1
    drawline -nr @UnInstall $rgb(0,255,0) 1 167 40 167 $2
    drawdot @UnInstall
    if ($1 > 20) { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.2 $calc($1 - 2) $calc($2 - 2) Sides }
    else { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.2 123 167 Top }
  }
  elseif ($3 == Top) {
    drawline -nr @UnInstall $rgb(0,255,0) 1 123 20 $1 20
    drawline -nr @UnInstall $rgb(0,255,0) 1 167 20 $2 20
    drawdot @UnInstall
    if ($1 <= 145) { .timerDrawPctBox -m 1 10 CUninstall.DrawPctBox.2 $calc($1 + 2) $calc($2 - 2) Top }
    else {
      drawpic -n @UnInstall 132 24 90 0 8 13 $scriptdirnumbers.bmp
      drawpic -n @UnInstall 142 24 90 0 8 13 $scriptdirnumbers.bmp
      drawpic -n @UnInstall 152 24 90 0 8 13 $scriptdirnumbers.bmp
      drawdot @UnInstall
      CUninstall.DrawText Preparing for Uninstallation
      .timerPrepWait1 -m 1 500 CUninstall.DrawText Preparing for Uninstallation.
      .timerPrepWait2 -m 1 1000 CUninstall.DrawText Preparing for Uninstallation..
      .timerPrepWait3 -m 1 1500 CUninstall.DrawText Preparing for Uninstallation...
      .timerInstallWait 1 2 UnInstallIt
    }
  }
}

alias -l CUninstall.CountUp {
  var %CUninstall.FirstNum $int($calc($1 / 100))
  var %CUninstall.SecondNum $int($calc($1 / 10))
  var %CUninstall.ThirdNum $right($calc($1 / 1),1)
  if (%CUninstall.secondNum == 10) { var %CUninstall.SecondNum 0 }
  drawpic -n @UnInstall 132 24 $calc(%CUninstall.FirstNum * 9) 0 8 13 $scriptdirnumbers.bmp
  drawpic -n @UnInstall 142 24 $calc(%CUninstall.SecondNum * 9) 0 8 13 $scriptdirnumbers.bmp
  drawpic -n @UnInstall 152 24 $calc(%CUninstall.ThirdNum * 9) 0 8 13 $scriptdirnumbers.bmp
  drawrect -nfr @UnInstall $rgb(0,255,0) 1 31 61 $calc(($1 / 100) * 230) 19
  drawdot @UnInstall
}

alias -l CUninstall.DrawText {
  drawrect -nfr @UnInstall $rgb(0,0,0) 1 0 90 300 50
  var %CUninstall.length $len($1-)
  var %CUninstall.textToDraw $lower($1-)
  var %CUninstall.counter 1
  var %CUninstall.xposition 10
  while (%CUninstall.counter <= %CUninstall.length) {
    if ($mid(%CUninstall.textToDraw, [ %CUninstall.counter ] , 1) == .) { drawpic -n @UnInstall %CUninstall.xposition 95 260 0 8 12 $scriptdirletters2.bmp }
    elseif ($mid(%CUninstall.textToDraw, [ %CUninstall.counter ] , 1) == !) { drawpic -n @UnInstall %CUninstall.xposition 95 270 0 8 12 $scriptdirletters2.bmp }
    elseif ($mid(%CUninstall.textToDraw, [ %CUninstall.counter ] , 1) == $chr(32)) { }
    else { drawpic -n @UnInstall %CUninstall.xposition 95 $calc(($asc($mid(%CUninstall.textToDraw, [ %CUninstall.counter ] , 1)) - 97) * 10) 0 8 12 $scriptdirletters2.bmp }
    inc %CUninstall.xposition 9
    inc %CUninstall.counter
  }
  drawdot @UnInstall
}

alias -l UnInstallIt {
  CUninstall.DrawText Uninstalling program files..
  CUninstall.CountUp 1
  CUninstall.UnloadScriptFiles 1 4
}

alias -l CUninstall.UnloadScriptFiles {
  var %CUnInstall.filenames Dates.mrc Addevent.mrc Calendar.mrc EventManager.mrc
  .unload -rs $gettok(%CUnInstall.filenames,$1,32)
  CUninstall.CountUp $2
  if ($1 < 4) { .timerUnloadScript -m 1 50 CUninstall.UnloadScriptFiles $calc($1 + 1) $calc($2 + $rand(3,4)) }
  else {
    unset %c.*
    CUninstall.CountUp $calc($2 + 1)
    CUninstall.DrawText Uninstalling program files..Done
    CUninstall.CountUp $calc($2 + 2)
    if (%CUnInstall.delete == $true) {
      CUninstall.DrawText Deleting files..
      .timerRemoveFiles -m 1 100 CUninstall.RemoveFiles 1 $calc($2 + 2)
    }
    else { .timerFakeUninstall -m 1 100 CUninstall.FakeUninstall $calc($2 + 2) }
  }
}

alias -l CUninstall.RemoveFiles {
  var %CUnInstall.filenames Dates.mrc Addevent.mrc Calendar.mrc EventManager.mrc Menus.mrc install.mrc next.bmp previous.bmp bg1.bmp bg1_sml.bmp bg2.bmp bg2_sml.bmp bg3.bmp bg3_sml.bmp CalendarLogo.jpg arrows.bmp readme.txt events.dat busydays.dat
  .remove [ %Calendar.directory $+ [ $gettok(%CUnInstall.filenames,$1,32) ] ]
  CUninstall.CountUp $2
  if ($1 < 19) { .timerRemoteFiles -m 1 50 CUninstall.RemoveFiles $calc($1 + 1) $calc($2 + $rand(3,4)) }
  else {
    .timers off
    CUninstall.CountUp 100
    CUninstall.DrawText Deleting files..Done
    SuccessfulUnInstall
  }
}

alias -l CUninstall.FakeUninstall {
  if ($1 > 100) { CUninstall.CountUp 100 }
  else { CUninstall.CountUp $1 }
  if ($1 < 100) { .timerFakeInstall -m 1 50 CUninstall.FakeUninstall $calc($1 + $rand(1,4)) }
  else { SuccessfulUnInstall }
}

; ---------------------------------
; Successful UnInstallation
; ---------------------------------
alias -l SuccessfulUnInstall {
  if (%CUnInstall.delete == $true) {
    .remove [ %Calendar.directory $+ numbers.bmp ]
    .remove [ %Calendar.directory $+ letters2.bmp ]
    if ($findfile( [ %Calendar.directory ] ,*.*,1) != $null) { echo 4 -a Unable to remove %Calendar.directory }
    else { .rmdir %Calendar.directory }
  }
  unset %Calendar.* %CUnInstall.* %CUninstall.* %c.* %CAdd.* %CalMenu.* %CalCredits.* %EventManager.*
  .timerClose 1 3 window -c @UnInstall
  .timerUnload 1 4 .unload -rs $script
  echo 4 -s *** Uninstallation of Calendar was successful!
}

; ----------------------------------------
; Draw a background for the install window
; ----------------------------------------
alias -l DrawBackground {
  var %CUnInstall.r 37
  var %CUnInstall.g 123
  var %CUnInstall.b 164
  var %CUnInstall.Ypos 1
  :DrawBG
  drawrect -nrf $1 $rgb( %CUnInstall.r , %CUnInstall.g , %CUnInstall.b ) 1 1 %CUnInstall.YPos 600 2
  if (%CUnInstall.r > 0) { dec %CUnInstall.r }
  if (%CUnInstall.g > 0) { dec %CUnInstall.g }
  if (%CUnInstall.b > 0) { dec %CUnInstall.b }
  var %CUnInstall.YPos $calc(%CUnInstall.YPos + 2)
  if (%CUnInstall.Ypos < 350) { goto DrawBG }
}

; -------------------------------------------
; Draw a background to the specified window.
; Paramaters: DrawBG @Window Width Height
; -------------------------------------------
alias DrawBG {
  if (%Calendar.Background == 3) {
    var %Cal.r 37
    var %Cal.g 123
    var %Cal.b 164
    var %Cal.Ypos 1
    :DrawBG
    drawrect -nrf $1 $rgb( %Cal.r , %Cal.g , %Cal.b ) 1 1 %Cal.YPos $2 2
    if (%Cal.r > 0) { dec %Cal.r }
    if (%Cal.g > 0) { dec %Cal.g }
    if (%Cal.b > 0) { dec %Cal.b }
    var %Cal.YPos $calc(%Cal.YPos + 2)
    if (%Cal.Ypos < $int($calc($3 / 2))) { goto DrawBG }
    var %Cal.r 37
    var %Cal.g 123
    var %Cal.b 164
    var %Cal.Ypos $calc($3 - 2)
    :DrawBG2
    drawrect -nrf $1 $rgb( %Cal.r , %Cal.g , %Cal.b ) 1 1 %Cal.YPos $2 2
    if (%Cal.r > 0) { dec %Cal.r }
    if (%Cal.g > 0) { dec %Cal.g }
    if (%Cal.b > 0) { dec %Cal.b }
    var %Cal.YPos $calc(%Cal.YPos - 2)
    if (%Cal.Ypos > $int($calc(($3 / 2) - 1))) { goto DrawBG2 }
  }
  elseif (%Calendar.background == 2) { drawrect -nrf $1 $rgb(0,0,0) 1 0 0 $2 $3 }
  else {
    var %Cal.xpos 1
    var %Cal.ypos 1
    while (%Cal.ypos < $3) {
      drawpic -nc $1 %Cal.xpos %Cal.ypos [ %Calendar.bgpicture ]
      if (%Cal.xpos > $calc($2 + 1)) {
        var %Cal.xpos 1
        var %Cal.ypos $calc(%Cal.ypos + 95)
      }
      else { var %Cal.xpos $calc(%Cal.xpos + 95) }
    }
  }
}

; -------------------------------------------
; Everything needed to draw clocks into any
; of the event windows..
; -------------------------------------------

; -----------------------
; /Clock @window <x> <y>
; -----------------------
alias clock {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 120 120
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 55) $3 12
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 83) $calc($3 + 5) 1
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 106) $calc($3 + 28) 2
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 115) $calc($3 + 53) 3
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 106) $calc($3 + 80) 4
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 83) $calc($3 + 103) 5
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 58) $calc($3 + 109) 6
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 33) $calc($3 + 103) 7
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 9) $calc($3 + 78) 8
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $2 $calc($3 + 53) 9
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 6) $calc($3 + 30) 10
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 28) $calc($3 + 6) 11
  drawrect -nrfe $1 $rgb(0,0,0) 1 $calc($2 + 57) $calc($3 + 57) 6 6
  drawrect $1
}

; ---------------------------------------------
; /AddHands <Hours> <Minutes> <@Window> <x> <y>
; ---------------------------------------------
alias AddHands {
  if ($1 < 6) {
    if ($1 >= 3) {
      var %CAddClock.abshr1 $abs($calc($1 - 6))
      var %CAddClock.abshr1 $calc(%CAddClock.abshr1 + (1 - ($2 / 60)))
      var %CAddClock.abshr1 $calc(%CAddClock.abshr1 - 1)
      var %CAddClock.abshr2 $calc($1 - 3)
      var %CAddClock.abshr2 $calc(%CAddClock.abshr2 + ($2 / 60))
    }
    else { var %CAddClock.abshr $calc($1 + ($2 / 60)) }
    if (%CAddClock.abshr == 0) { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) + (%CAddClock.abshr * 20))) $int($calc($5 + ($1 * 20) + 15)) }
    elseif (%CAddClock.abshr == 3) { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc((($4 + 60) + (%CAddClock.abshr * 20)) - 15)) $int($calc($5 + ($1 * 20))) }
    elseif ($1 < 3) { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) + (%CAddClock.abshr * 20))) $int($calc($5 + (%CAddClock.abshr * 20))) }
    else { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) + (%CAddClock.abshr1 * 20))) $int($calc((($5 + 60) + (%CAddClock.abshr2 * 20)))) }
  }
  else {
    if ($1 >= 9) {
      var %CAddClock.abshr $abs($calc($1 - 12))
      var %CAddClock.abshr $calc(%CAddClock.abshr + (1 - ($2 / 60)))
      var %CAddClock.abshr $calc(%CAddClock.abshr - 1)
    }
    else {
      var %CAddClock.abshr $calc($1 - 6)
      var %CAddClock.abshr $calc(%CAddClock.abshr + ($2 / 60))
    }
    if (%CAddClock.abshr == 6) { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) + (%CAddClock.abshr * 20))) $int($calc($5 + ($1 * 20) - 15)) }
    elseif (%CAddClock.abshr == 9) { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc((($4 + 60) - (%CAddClock.abshr * 20)) + 15)) $int($calc($5 + (%CAddClock.abshr * 20))) }
    elseif ($1 < 9) { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) - (%CAddClock.abshr * 20))) $int($calc((($5 + 120) - (%CAddClock.abshr * 20)))) }
    else { drawline -r $3 $rgb(255,0,0) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) - (%CAddClock.abshr * 20))) $int($calc($5 + (%CAddClock.abshr * 20))) }
  }
  if ($2 <= 30) {
    if (($2 > 15) && ($2 < 30)) { var %CAddClock.abshr $abs($calc($2 - 30)) }
    else { var %CAddClock.abshr $2 }
    if ($2 == 0) { drawline -r $3 $rgb(0,0,255) 1 $calc($4 + 60) $calc($5 + 60) $calc($4 + 60) $int($calc($5 + ($2 * 4) + 15)) }
    elseif ($2 == 30) { drawline -r $3 $rgb(0,0,255) 1 $calc($4 + 60) $calc($5 + 60) $calc($4 + 60) $int($calc($5 + ($2 * 4) - 15)) }
    elseif ($2 == 15) { drawline -r $3 $rgb(0,0,255) 1 $calc($4 + 60) $calc($5 + 60) $int($calc((($4 + 60) + ( %CAddClock.abshr * 4)) - 15)) $int($calc($5 + ($2 * 4))) }
    else { drawline -r $3 $rgb(0,0,255) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) + ( %CAddClock.abshr * 4))) $int($calc($5 + ($2 * 4))) }
  }
  else {
    if ($2 > 45) { var %CAddClock.abshr $abs($calc($2 - 60)) }
    else { var %CAddClock.abshr $calc($2 - 30) }
    var %CAddClock.abshr2 $abs($calc($2 - 60))
    if ($2 == 45) { drawline -r $3 $rgb(0,0,255) 1 $calc($4 + 60) $calc($5 + 60) $int($calc((($4 + 60) - ( %CAddClock.abshr * 4)) + 15)) $int($calc($5 + (%CAddClock.abshr2 * 4))) }
    else { drawline -r $3 $rgb(0,0,255) 1 $calc($4 + 60) $calc($5 + 60) $int($calc(($4 + 60) - ( %CAddClock.abshr * 4))) $int($calc($5 + (%CAddClock.abshr2 * 4))) }
  }
}

; -----------------------
; /ClearClock @window <x> <y>
; -----------------------
alias ClearClock {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 120 120
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 55) $3 12
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 83) $calc($3 + 5) 1
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 106) $calc($3 + 28) 2
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 115) $calc($3 + 53) 3
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 106) $calc($3 + 80) 4
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 83) $calc($3 + 103) 5
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 58) $calc($3 + 109) 6
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 33) $calc($3 + 103) 7
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 9) $calc($3 + 78) 8
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $2 $calc($3 + 53) 9
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 6) $calc($3 + 30) 10
  drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 9 $calc($2 + 28) $calc($3 + 6) 11
  drawrect -nrfe $1 $rgb(0,0,0) 1 $calc($2 + 57) $calc($3 + 57) 6 6
  drawrect $1
}

; ---------------------------------
; Highlight whatever time box was
; clicked. Blue background, white
; text.
; SelectTime @ x y w h text
; ---------------------------------
alias SelectTime {
  drawrect -nrf $1 $rgb(0,0,128) 1 $calc($2 + 2) $calc($3 + 2) $calc($4 - 4) $calc($5 - 4)
  if ($6 != $null) { drawtext -nr $1 $rgb(255,255,255) "Times New Roman" 14 $int($calc((($4 - 4) / 2) - ($width($6-,Times New Roman,14,1,1) / 2) + ($2 + 2) )) $int($calc((($5 - 4) / 2) - ($height($6-,Times New Roman,14) / 2) + ($3 + 2) )) $6- }
  drawrect $1
}

; -------------------------------------
; Draw a clickable button.
; Alias for both unclicked and clicked
; Accepts paramaters as follows:
; DrawButton window x y w h text
; -------------------------------------

alias DrawButton {
  drawrect -nrf $1 $rgb(face) 1 $2 $3 $4 $5
  drawrect -nr $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawline -nr $1 $rgb(hilight) 1 $2 $calc($3 + $5 - 1) $2 $calc($3 + 1) $calc($2 + $4) $calc($3 + 1)
  if ($6 != $null) { drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 14 $int($calc(($4 / 2) - ($width($6-,Times New Roman,14,1,1) / 2) + $2 )) $int($calc(($5 / 2) - ($height($6-,Times New Roman,14) / 2) + $3 )) $6- }
  drawrect $1
}

alias DrawButtonDown {
  drawrect -nrf $1 $rgb(face) 1 $2 $3 $4 $5
  drawrect -nr $1 $rgb(frame) 1 $2 $3 $4 $5
  if ($6 != $null) { drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 14 $int($calc(($4 / 2) - ($width($6-,Times New Roman,14,1,1) / 2) + $2 )) $int($calc(($5 / 2) - ($height($6-,Times New Roman,14) / 2) + $3 )) $6- }
  drawrect $1
}

; ---------------------------------------------
; Draw a RadioButton.
; Alias for all 3 phases - UnClicked, Clicked,
; and clicking.
; Accepts paramaters as follows:
; DrawRadio window x y w h
; ---------------------------------------------

alias DrawRadio {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawrect -nre $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawrect $1
}

alias DrawRadioClicking {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawrect -nre $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawrect -nrfe $1 $rgb(face) 1 $calc($2 + 1) $calc($3 + 1) $calc($4 - 1) $calc($5 - 1)
  drawrect -nrfe $1 $rgb(0,0,0) 1 $calc($2 + 3) $calc($3 + 3) $calc($4 - 6) $calc($5 - 6)
  drawrect $1
}

alias DrawRadioClicked {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawrect -nre $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawrect -nrfe $1 $rgb(0,0,0) 1 $calc($2 + 3) $calc($3 + 3) $calc($4 - 6) $calc($5 - 6)
  drawrect $1
}

; ---------------------------------
; Draw an edit box. Unfortunately,
; This one can't be edited :\
; Accepts paramaters as follows:
; EditBox window x y w h text
; ---------------------------------


; --------------
;   Mouse Menu
; --------------
menu @UnInstall {
  sclick: {
    if (%CUnInstall.stepnum == 1) {
      if ($inrect($mouse.x,$mouse.y,152,82,85,30) == $true) {
        DrawButtonDown @UnInstall 152 82 85 30 Cancel
        set %CUnInstall.clicked Cancel
      }
      elseif ($inrect($mouse.x,$mouse.y,57,82,85,30) == $true) {
        DrawButtonDown @UnInstall 57 82 85 30 Uninstall
        set %CUnInstall.clicked Install
      }
      elseif ($inrect($mouse.x,$mouse.y,30,48,10,10) == $true) {
        DrawRadioClicking @UnInstall 30 48 10 10
        set %CUnInstall.clicked BG2
      }
      else { }
    }
  }
  uclick: {
    if (%CUnInstall.stepnum == 1) {
      if (($inrect($mouse.x,$mouse.y,152,82,85,30) == $true) && (%CUnInstall.clicked == Cancel)) {
        DrawButton @UnInstall 152 82 85 30 Cancel
        set %CUnInstall.success cancelled!
        window -c @UnInstall
      }
      elseif (($inrect($mouse.x,$mouse.y,57,82,85,30) == $true) && (%CUnInstall.clicked == Install)) {
        inc %CUnInstall.stepnum
        UnInstallGUI3
      }
      elseif (($inrect($mouse.x,$mouse.y,30,48,10,10) == $true) && (%CUnInstall.clicked == BG2)) {
        DrawRadioClicked @UnInstall 30 48 10 10
        set %CUnInstall.delete $true
      }
      else {
        DrawButton @UnInstall 57 82 85 30 Uninstall
        DrawButton @UnInstall 152 82 85 30 Cancel
        DrawRadio @UnInstall 30 48 10 10
      }
    }
  }
}

; --------------
;   Mouse Menu
; --------------
menu @Select {
  sclick: {
    if ($inrect($mouse.x,$mouse.y,125,230,85,25) == $true) {
      DrawButtonDown @Select 125 230 85 25 Cancel
      set %CBackground.clicked Cancel
    }
    elseif ($inrect($mouse.x,$mouse.y,35,230,85,25) == $true) {
      DrawButtonDown @Select 35 230 85 25 Select
      set %CBackground.clicked Install
    }
    elseif ($inrect($mouse.x,$mouse.y,83,47,10,10) == $true) {
      DrawRadioClicking @Select 83 47 10 10
      set %CBackground.clicked BG1
    }
    elseif ($inrect($mouse.x,$mouse.y,83,97,10,10) == $true) {
      DrawRadioClicking @Select 83 97 10 10
      set %CBackground.clicked BG2
    }
    elseif ($inrect($mouse.x,$mouse.y,83,147,10,10) == $true) {
      DrawRadioClicking @Select 83 147 10 10
      set %CBackground.clicked BG3
    }
    elseif ($inrect($mouse.x,$mouse.y,10,181,57,25) == $true) {
      DrawButtonDown @Select 10 181 57 25 Other...
      set %CBackground.clicked BG4
    }
    else { }
  }
  uclick: {
    if (($inrect($mouse.x,$mouse.y,125,230,85,25) == $true) && (%CBackground.clicked == Cancel)) {
      DrawButton @Select 125 230 85 25 Cancel
      unset %CBackground.* %CUninstall.* %Calendar.new*
      window -c @Select
    }
    elseif (($inrect($mouse.x,$mouse.y,35,230,85,25) == $true) && (%CBackground.clicked == Install)) {
      DrawButton @Select 35 230 85 25 Select
      set %Calendar.background [ %Calendar.newbackground ]
      if (%Calendar.newbgpicture) { set %Calendar.bgpicture [ %Calendar.newbgpicture ] }
      unset %CBackground.* %CUninstall.* %Calendar.new*
      window -c @Select
    }
    elseif (($inrect($mouse.x,$mouse.y,83,47,10,10) == $true) && (%CBackground.clicked == BG1)) {
      DrawRadioClicked @Select 83 47 10 10
      DrawRadio @Select 83 97 10 10
      DrawRadio @Select 83 147 10 10
      set %Calendar.newbackground 1
      set %Calendar.newbgpicture [ %Calendar.directory ] $+ bg1.bmp
    }
    elseif (($inrect($mouse.x,$mouse.y,83,97,10,10) == $true) && (%CBackground.clicked == BG2)) {
      DrawRadioClicked @Select 83 97 10 10
      DrawRadio @Select 83 47 10 10
      DrawRadio @Select 83 147 10 10
      set %Calendar.newbackground 2
    }
    elseif (($inrect($mouse.x,$mouse.y,83,147,10,10) == $true) && (%CBackground.clicked == BG3)) {
      DrawRadioClicked @Select 83 147 10 10
      DrawRadio @Select 83 47 10 10
      DrawRadio @Select 83 97 10 10
      set %Calendar.newbackground 3
    }
    elseif (($inrect($mouse.x,$mouse.y,10,181,57,25) == $true) && (%CBackground.clicked == BG4)) {
      DrawButton @Select 10 181 57 25 Other...
      set %Calendar.newbackground 1
      set %CBackground.prevback [ %Calendar.bgpicture ]
      set %Calendar.newbgpicture $sfile(%Calendar.directory , Choose a Background,Select)
      if (($pic( %Calendar.newbgpicture ).height != 96) || ($pic( %Calendar.newbgpicture ).width != 96)) {
        EditBox @Select 70 184 165 20 Background must be 96x96
        set %Calendar.newbgpicture [ %CBackground.prevback ]
      }
      else {
        EditBox @Select 70 184 165 20
        drawtext -rc @Select $rgb(0,0,0) "Times New Roman" 14 $int($calc((165 / 2) - ($width(%Calendar.bgpicture,Times New Roman,14,1,1) / 2) + 109 )) $int($calc((20 / 2) - ($height(%Calendar.bgpicture,Times New Roman,14) / 2) + 184 )) 165 20 %Calendar.bgpicture
      }
    }
    else {
      if (%CBackground.clicked == BG3) { DrawRadio @Select 83 47 10 10 | DrawRadio @Select 83 97 10 10 }
      elseif (%CBackground.clicked == BG2) { DrawRadio @Select 83 47 10 10 | DrawRadio @Select 83 147 10 10 }
      elseif (%CBackground.clicked == BG1) { DrawRadio @Select 83 97 10 10 | DrawRadio @Select 83 147 10 10 }
      else { DrawRadio @Select 83 47 10 10 | DrawRadio @Select 83 97 10 10 | DrawRadio @Select 83 147 10 10 }
      DrawButton @Select 10 181 57 25 Other...
      DrawButton @Select 35 230 85 25 Select
      DrawButton @Select 125 230 85 25 Cancel
    }
  }
}

menu @About {
  sclick: { window -c @About }
}

menu @Credits {
  sclick: {
    unset %CalCredit.*
    .timerCredit* off
    hfree CreditNames
    CreditWindowClose
  }
}

on 1:close:@: {
  if ($target == @Calendar) { unset %c.* %CalMenu.* }
  elseif ($target == @Credits) { .timerCredit* off | unset %CalCredit.* | hfree CreditNames }
  elseif ($target == @Event) { unset %EventManager.* %CalMenu.* }
  elseif ($target == @Install) { unset %CInstall.* }
  elseif ($target == @Uninstall) { unset %CUnInstall.* }
}
