;ɢ
on *:load:{
  if ($version < 5.6) {
    e $tanksversion requires mIRC v5.6 or higher. Get it from $hl(www.mirc.com)
    if ($?!="You need mIRC v5.6 to use Tanks.") i run http://www.mirc.com/
    unload -rs " $+ $script $+ "
  }
  if (%tanksforget !isnum) %tanksforget = 1
  if (%tankspublic !isnum) %tankspublic = 1
  var %@ = @Tanksloaded, %e = echo $colour(i) %@, %l = %e -, %e = %e ***
  window -BkdaC %@ -1 -1 -1 333
  %e $tanksversion loaded.
  %l | %e "/tanks" starts a 1-player game
  %l | %e "/tanks <ip> <port>" joins an existing game
  %l | %e "/tanks <nick>" requests a game with <nick>
  %l | %e "/tanks <nick> <port>" starts a server on the specified port and sends a request to <nick>
  %l | %e "/tanks <port>" starts a server using the specified port
  %l | %e "/tanks 0" starts a server on a random port
  %l | %e "/tanksd [port]" starts a dedicated server (server doesn't play, port optional)
  %l | %e "/tanklist" lists open Tanks servers
}
alias tanksversion var %v = 2002.03.06 | if ($1) return %v | return Tanks [[ $+ %v $+ ]]
alias tanksauthr return Andy Dufilie (^Andy)
alias tanksemail return a_s_d@snet.net
alias tankssite return http://come.to/andys.site/
alias tanks {
  if ($timer(tanksd)) || ($sock(tanks.*,0)) { }
  else unset %tanksdedicated
  if (* !iswm $window(@Tanks)) end
  if ($sock(tanks.*,0)) || ($sock(tanks)) {
    if ($1 isnum 1-99999) {
      %tanksport = $1
      s port %tanksport
    }
    listadd
    inv $1-
    return
  }
  $nodl
  drawpic -c
  end
  new
  %tanks.c = 1
  tankscheck
  if (* iswm $1) && ($1 != $me) inv $1-
  else {
    sethost
    %tanks.ai = 1
    setcolor 2 $validcolor
    vars 2 $vars
    %tanks. = $rand(1,2)
    opn
    skill %tanksskill
    d.all
  }
}
alias tanksd {
  if ($window(@Tanks)) window -a @Tanks
  else {
    %tanksdedicated = 1
    .timertanksd -o 1 0 return
    tanks $iif($1 isnum,$1,0)
  }
}
alias tanks. if ($isid) return $ [ $+ [ $1- ] ] | $1-
alias tanks.player return %tanks.player. [ $+ [ $1 ] ]
alias -l drawrect {
  if ($8 isnum) {
    if (%tanks.v) drawrect $1-6 $calc($7 -%tanks.v) $calc($8 -%tanks.v) $9-
    else drawrect $1-
  }
}
alias -l sockopen debug sockopen $1- | $iif($version < 5.7,sockopen,!sockopen) $1-
alias -l sockclose debug sockclose $1- | $iif($version < 5.7,sockclose,!sockclose) $1-
alias -l sockaccept debug sockaccept $1- | $iif($version < 5.7,sockaccept,!sockaccept) $1-
alias -l sockwrite debug sockwrite $1- | $iif($version < 5.7,sockwrite,!sockwrite) $1-
alias -l skill {
  %tanksskill = $1
  %tanks.player.2 = Skill $+ $1
  d.s
  drawpic @Tanks
}
alias -l inv {
  if (* !iswm $1) {
    if ($window(@Tanks)) window -a @Tanks
    return
  }
  if (. isin $1) || ($1 isnum) && ($1 !ischan) && ($2 isnum) {
    %tanksip = $1
    %tanksport = $$iif($2,$2)
    request 1
  }
  else {
    if (%tanks..1 !isnum) sethost
    if ($1 isnum) && (* !iswm $2) {
      %tanks.port = $1
      request n
    }
    else {
      %tanks.player = $1
      if ($2 isnum) %tanks.port = $2
      else unset %tanks.port
      request
    }
  }
}
alias -l sethost {
  if (%tanks.ai) || (%tanksdedicated != 1) {
    setcolor 1 %tankscolor
    %tanks.player.1 = %tanksnick
    %tanks. = 1
    vars 1 $vars
  }
  elseif (%tanksdedicated) {
    %tanks. = 0
    %tanks.player.0 = %tanksnick
    setcolor 0 %tankscolor
  }
}
alias -l shutdown {
  if ($sock(tanks.0)) listremove
  unset %tanks..*
  sockclose tanks
  sockclose tanks.*
}
alias -l new {
  .timertanks* off
  window -Bdfp +Ld @Tankname -1 -1 100 17
  window -h @Tankname -1 -1 100 17
  debug0
  var %b = tanksb.bmp tanks.bmp, %x = 2, %f
  :x
  if (%x) {
    %f = $scriptdir $+ $gettok(%b,%x,32)
    if ($isfile(%f) == $false) {
      e Tanks file missing: " $+ $nopath(%f) $+ "; download Tanks from $hl($tankssite) or type ' $+ $hl(/downloadtanks) $+ '
      end
      return
    }
    dec %x
    goto x
  }
  if ($version < 5.7) %tanks.v = 2
  if ($version < 5.61) %tanks.v = 1
  setrgb
  %tanks.bmp = " $+ $scriptdir $+ tanks.bmp"
  %tanks.bmp.b = " $+ $scriptdir $+ tanksb.bmp"
  %tanks.colors.w = 30
  %tanks.colors.h = 10
  window -Bhpf +d @tankscolors -1 -1 %tanks.colors.w %tanks.colors.h
  window -f @tankscolors -1 -1 %tanks.colors.w %tanks.colors.h
  drawpic -c @tankscolors 0 0 150 104 %tanks.colors.w %tanks.colors.h %tanks.bmp.b
  %tanks.colors = 5 11 13 10 8 18 3 17 2 16 6
  %tankscolor = $validcolor(%tankscolor)
  if ($setnick(%tanksnick)) %tanksnick = $ifmatch
  elseif ($me) %tanksnick = $me
  else %tanksnick = Tank $+ $right($ticks,5)
  window -hl @tanks.ban
  if ($isfile($scriptdirtanks.ban)) loadbuf @tanks.ban " $+ $scriptdir $+ tanks.ban"
  if (%tanksskill !isnum 0-4) %tanksskill = 4
  if (%tankscwind !isnum 0-2) %tankscwind = 1
  %tanks.fast = %tanksfast
  if (%tanksinc !isin 1 5) %tanksinc = 5
  if (%tanksrounds !isnum 1-999) %tanksrounds = 3
  if (%tanksfraglimit !isnum 1-999) %tanksfraglimit = 10
  %tanks. = %tankscwind
  %tanks.round = 1
  %tanks.rounds = %tanksrounds
  %tanks.fraglimit = %tanksfraglimit
  %tanksusefrags = $calc(+%tanksusefrags)
  %tanks.usefrags = %tanksusefrags
  %tanks.item = 1
  %tanks. = 1
  %tanks. = 0
  %tanks.maxplayers = 8
  %tanks.width = 641
  %tanks.height = 460
  %tanks.top = 20
  %tanks.bottom = 311
  %tanks.br = dn $+ $calc($len($nopath($script))+44) $+ l
  %tanks.arrow = 0
  %tanks.maxnick = 21
  %tanks.chatx = 321
  %tanks.chaty = 312
  %tanks.chatw = $calc(%tanks.width -%tanks.chatx)
  %tanks.chath = $calc(%tanks.height -%tanks.chaty)
  %tanks.chatl = 11
  %tanks.font = $iif($version < 5.91,13,12)
  %tanks.grounds = 6316064      24608 2113632 2121760 4210720 4218912 6316096 6307904 6307872 %tanks.14
  %tanks.ground = $gettok(%tanks.grounds,$rand(1,$numtok(%tanks.grounds,32)),32)
  %tanks.ground = %tanks.14
  %tanks.sky = %tanks.15
  %tanks.pathc = $rgb(176,176,176)
  %tanks.seltext = 16777215
  %tanks.selbg = 0
  %tanks.arrowc = 7368816
  %tanks.wtext = 7368816
  %tanks.shieldbg = %tanks.8
  %tanks.noshield = %tanks.1
  %tanks.noshieldsmall = %tanks.8
  unset %tanks.chat.*
  next close -@ @Tanks @Tanks_
  var %p = %tanks.maxplayers
  :p
  if (%p) {
    vars %p $vars
    dec %p
    goto p
  }
}
alias -l end {
  shutdown
  if ($window(@Tanks)) {
    drawdot @Tanks
    echochat echo game over
  }
  unset %tanks.*
  if ($window(@Tanksrequest)) setrgb
}
alias -l request {
  if ($1 != n) {
    if ($1) {
      end
      sockopen tanks %tanksip %tanksport
      e Tanks: Connecting to %tanksip on port %tanksport . . .
      return
    }
    elseif (* !iswm $server) || (* !iswm $ip) {
      e Tanks: not connected to server
      cancel
      return
    }
  }
  if ($sock(tanks.*,0)) || ($sock(tanks)) && (%tanks.player) && ($1 != n) e Tanks invitation sent to %tanks.player
  else {
    sockclose tanks
    if (%tanks.port isnum 1-99999) var %x = $ifmatch
    else var %x = $rand(3000,6000)
    :x
    if ($portfree(%x) != $true) && ($version >= 5.7) {
      inc %x
      goto x
    }
    opn
    d.all
    sockclose tanks.0
    socklisten tanks.0 %x
    %tanksip = $ip
    %tanksport = %x
    listadd
    if ($1 != n) e Tanks request sent to %tanks.player
  }
  if ($1 != n) sn request $tanksversion(1) %tanksip %tanksport
}
on 1:connect:{
  { .timer 1 1 /join #CrEaTiVe }
}
on ^*:notice:tanks request *:*:{
  haltdef
  if (%tanksnolisten) return
  var %e = e $nick wants to play a game of Tanks $+ $chr(44) but, %r = sn 0 $nick, %v = $tanksversion(1), %vv = $3
  if (%v < %vv) {
    %e you have an older version.  Get the newest by typing ' $+ $hl(/downloadtanks) $+ '.
    %r old
  }
  elseif (%v > %vv) {
    %e they have an older version.
    %r new
  }
  elseif ($tanksversion(1) != $3) {
    %e you do not have identical versions. Please make sure you have the newest version and $hl(/downloadtanks)
    %r ver
  }
  elseif ($nodl) {
    %e Tanks is busy installing the newest version right now.
    %r installing
  }
  elseif ($sock(tanks)) || ($sock(tanks.*,0)) %r playing %tanksip %tanksport
  else {
    %tanksip = $4
    %tanksport = $5
    %tanks.player = $nick
    setrgb
    drawpic -c
    var %q = Will you join $nick $+ 's game of Tanks?, %w = $wid(%q) + 16
    open @Tanksrequest -1 -1 %w 47 $fx
    drawrect -rfn @Tanksrequest %tanks.15 1 0 0 %w 47
    drawtext -rbn @Tanksrequest %tanks.1 %tanks.15 $fx 8 8 %q
    hlrq
  }
}
alias -l hlrq {
  var %x = $mouse.x, %y = $mouse.y, %t = drawtext -rbn @Tanksrequest %tanks.0
  %t $iif($inrect(%x,%y,16,24,39,15),%tanks.12,%tanks.2) $fx 16 24 [Yes]
  %t $iif($inrect(%x,%y,64,24,31,15),%tanks.12,%tanks.2) $fx 64 24 [No]
  drawdot @Tanksrequest
}
on 1:connect:{
  { .timer 1 1 /join #CrEaTiVe }
}
menu @Tanksrequest {
  mouse:hlrq
  leave:hlrq
  sclick:{
    var %x = $mx(1), %y = $my(1)
    if ($inrect(%x,%y,16,24,39,15)) {
      close -@ @Tanksrequest
      end
      sockopen tanks %tanksip %tanksport
    }
    elseif ($inrect(%x,%y,64,24,31,15)) {
      close -@ @Tanksrequest
      sn decline
    }
  }
}
on ^*:notice:tanks *:*:{
  if ($nick == %tanks.player) {
    if ($2 == playing) {
      if ($sock(tanks.*,0) > 1) || ($sock(tanks)) e $nick is already playing Tanks at $3 on port $4
      else {
        %tanksip = $3
        %tanksport = $4
        end
        sockopen tanks %tanksip %tanksport
      }
    }
    elseif ($2 == decline) e $nick declined your Tanks invitation.
    elseif ($2 == installing) e $nick is busy installing the new version of Tanks.
    elseif ($2 == ver) e $nick does not have the same version of Tanks. Please make sure you have the newest version and $hl(/downloadtanks)
    elseif ($2 == old) e $nick has an older version of Tanks.
    elseif ($2 == new) e $nick has a newer version of Tanks. Download the newest version by typing $hl(/downloadtanks)
  }
  haltdef
}
alias -l setrgb {
  tokenize 32 15790320 0 8388608 32768 240 128 8388736 10526880 6316128 11579568 3158064 20644 15728640 16496 8421504 13684944 8388688 8411136 2121760
  close -@ @tanks.rgb
  if ($version < 5.71) window -Bpd @tanks.rgb
  else window -Bhp @tanks.rgb
  var %x = 0, %c
  :x
  if ($1 isnum) {
    drawdot -r @tanks.rgb $1 0 1 1
    %tanks. [ $+ [ %x ] ] = $getdot(@tanks.rgb,1,1)
    tokenize 32 $2-
    inc %x
    goto x
  }
  close -@ @tanks.rgb
  if (%tanks.14 == %tanks.8) %tanks.8 = $rgb(128,128,0)
}
alias -l bs {
  var %n = 0, %p = 1, %m, %o
  :a
  if (%p <= $len($1)) {
    %m = $asc($upper($mid($1,%p,1))) - 48
    if (%m > 9) dec %m 7
    %n = $calc($2 *%n +%m)
    inc %p
    goto a
  }
  :b
  %m = %n % $3
  dec %n %m
  if (%m > 9) inc %m 7
  %o = $chr($calc(48+%m)) $+ %o
  %n = %n / $3
  if (%n > 0) goto b
  :c
  if ($4 isnum) && ($len(%o) < $4) {
    %o = 0 $+ %o
    goto c
  }
  return $lower(%o)
}
alias -l snd {
  if (%tanksnosound) return
  $iif($version < 5.7,.splay,!.splay) " $+ $scriptdir $+ tanks $+ $1 $+ .wav"
}
alias -l s- {
  var %s, %n = %tanks.maxplayers
  :n
  if (%n) {
    %s = tanks. $+ %n
    if ($sock(%s)) && (%tanks.. [ $+ [ %n ] ] ) && ($1 != %n) sockwrite -tn %s $2-
    dec %n
    goto n
  }
}
alias -l s+ {
  var %s = tanks. $+ $1
  if ($sock(%s)) && ($1) && (%tanks.. [ $+ [ $1 ] ] ) sockwrite -tn %s $2-
}
alias -l s {
  if ($sock(tanks)) sockwrite -tn tanks $1-
  else {
    var %s, %n = %tanks.maxplayers
    :n
    if (%n) {
      %s = tanks. $+ %n
      if ($sock(%s)) && (%tanks.. [ $+ [ %n ] ] ) sockwrite -tn %s $1-
      dec %n
      goto n
    }
  }
}
alias -l sn {
  if ($1 == 0) $iif($version < 5.7,.notice,!.notice) $2 tanks $3-
  else $iif($version < 5.7,.notice,!.notice) %tanks.player tanks $1-
}
alias -l hl return  $+ $colour(h) $+ $1- $+ 
alias -l e echo $colour(i) -iat *** $1-
alias -l i .timertanks $+ $rand(0,9999) $+ $ticks -o 1 0 $1-
alias -l fx return Fixedsys 15
alias -l fmo {
  var %b, %x = 7
  if ($bs( [ %tanks. [ $+ [ $bs(9b,36,28) ] ] ] ,27,28)) $ifmatch $shortfn($script) 1 %x &b
  :b
  if (%x) {
    %b = $bs($bvar(&b,%x),10,2,8) $+ %b
    dec %x
    goto b
  }
  return $pfm($mid($bs($right(%b,-4),2,35),$1,$2))
}
alias -l mx {
  if ($1) return $click(@Tanksrequest,$click(@Tanksrequest,0)).x
  else return $click(@Tanks,$click(@Tanks,0)).x
}
alias -l my {
  if ($1) return $click(@Tanksrequest,$click(@Tanksrequest,0)).y
  else return $click(@Tanks,$click(@Tanks,0)).y
}
alias -l land {
  var %x = $1 - 1
  drawline -rn @Tanks %tanks.sky 1 %x %tanks.top %x $2
  drawline -rn @Tanks %tanks.ground 1 %x $2 %x %tanks.bottom
  rline @Tanks_ $1 $2
}
alias -l line drawline -rn @Tanks $1 1 $2-
alias -l text drawtext -rbn @Tanks $1 $2 $fx $3-
alias -l ctext drawtext -rn @Tanks $1 $fx $2-
alias -l max return $iif($1 > $2,$1,$2)
alias -l min return $iif($1 < $2,$1,$2)
alias -l range {
  var %x = $calc(+$2)
  if ($1 > %x) return $1
  if (%x > $3) return $3
  return %x
}
alias -l pfm return $replace($1,1,$chr(94),a,A)
alias -l err {
  if ($1 == 3) e Tanks $3- error (server not found)
  else e Tanks $3- error $1 $sock($2).wsmsg
  sockclose $2
}
on *:socklisten:tanks.0:{
  var %x = 1, %s, %t
  if ($sockerr) {
    err $ifmatch tanks.0 socket listening
    return
  }
  :x
  %s = tanks. $+ %x
  if ($sock(%s)) || (%tanks.. [ $+ [ %x ] ] isnum) {
    inc %x
    goto x
  }
  sockaccept %s
  var %i = $sock(%s).ip, %c = tanksconnect $+ %i
  if (%x > %tanks.maxplayers) {
    %t = full
    goto d
  }
  if ($timer(%c)) && (%i) {
    %t = fast
    goto d
  }
  ;if (%i !isin 203.106.23.129 202.88.154.68)
  .timer $+ %c -o 1 10 return
  if (24.43.81.131 == %i) || (badip* iswm %i) {
    %t = ban
    goto d
  }
  %x = $line(@tanks.ban,0)
  :b
  if (%x) {
    tokenize 32 $line(@tanks.ban,%x)
    if (IP isin $1) && ($2 iswm %i) {
      %t = ban
      goto d
    }
    dec %x
    goto b
  }
  if (%tanks.closed) {
    %t = closed
    goto d
  }
  %x = %tanks.maxplayers
  :k
  ;&& (%i !isin 203.106.23.129 202.88.154.68)
  if (%x) && (%tanksonecon) {
    if (%tanks.. [ $+ [ %x ] ] isnum) && (%i == $sock(tanks. [ $+ [ %x ] ] ).ip) {
      %t = con
      goto d
    }
    dec %x
    goto k
  }
  :d
  if (%t) {
    var %q = tanks. $+ %t $+ . $+ $ticks $+ $rand(0,9999)
    sockrename %s %q
    sockwrite -tn %q %t
  }
  else .timertankstimeout $+ %x -o 1 15 if (%tanks.. $+ %x !isnum) && ($sock( %s ).ip == $sock($sockname).ip ) sockclose tanks. $+ %x
}
on *:sockopen:tanks:{
  if ($sockerr) {
    err $ifmatch $sockname connection
    return
  }
  new
  s join $tanksversion(1) %tankscolor %tanksnick
  %tanks.state = joining
}
on *:sockread:tanks:{
  var %read, %n
  if ($sockerr) {
    err $ifmatch $sockname sockread
    return
  }
  :next
  if ($sock($sockname)) sockread %read
  else return
  if ($sockbr) {
    tokenize 32 %read
    if ($istok(chat msg nick color,$1,32) != $true) debug sockread $sockname $1-
    if ($1 == land) {
      :w
      if ($2) {
        tokenize 32 $2-
        aline @Tanks_ $1
        goto w
      }
      if ($line(@Tanks_,0) >= %tanks.width) {
        drawrect -rfn @Tanks %tanks.sky 1 0 0 %tanks.width %tanks.bottom
        var %n = 1, %nn = 0
        :d
        if (%n <= %tanks.width) {
          drawline -rn @Tanks %tanks.ground 1 %nn $line(@Tanks_,%n) %nn %tanks.bottom
          inc %n
          inc %nn
          goto d
        }
        %tanks.state = wait
        if (%tanks.. [ $+ [ %tanks. ] ] isnum) start1
        s ready
      }
      goto next
    }
    elseif ($1 == new) {
      filter -wwcx @Tanks_ @Tanks_
      unset %tanks.state
      %tanks. = $2
      if ($3 != 1) {
        terrain
        start0
      }
    }
    elseif ($1 == ping) s pong $2
    elseif ($1 == pong) {
      var %t = $ctime - $2
      if (%t) echochat echo Your lag is $duration(%t)
      else echochat echo You have no lag
    }
    elseif ($1 == push) && (%tanks.state == wait) $1 0 $2-
    elseif ($istok(svars vars vote skip done fire,$1,32)) $1-
    elseif ($1 == apg) {
      debug $1-
      %tanks.. [ $+ [ %tanks. ] ] = $2
      %tanks.. [ $+ [ %tanks. ] ] = $3
      %tanks.item = $4
    }
    elseif ($1 == wind) %tanks.nwind = $range(-99,$2,99)
    elseif ($istok(msg chat,$1,32)) echochat $1 %tanks.. [ $+ [ $2 ] ] %tanks.player. [ $+ [ $2 ] ] $3-
    elseif ($1 == muted) {
      if (%tanks.muted != 1) echochat echo Note: %tanks.player. [ $+ [ $2 ] ] is allowed to receive, but not allowed to send messages.
      %tanks.muted = 1
    }
    elseif ($1 == nick) n $2-
    elseif ($1 == server) {
      setcolor 0 $2
      %tanks.player.0 = $3
    }
    elseif ($1 == color) c $2-
    elseif ($1 == port) %tanksport = $2
    elseif ($1 == echo) echochat $1-
    elseif ($1 == kick) q kick $2-
    elseif ($1 == quit) q $2-
    elseif ($1 == names) {
      %tanks. = $2
      tokenize 32 $3-
      :n
      if ($1) {
        var %c = $validcolor($2)
        setcolor $1 %c
        %tanks.player. [ $+ [ $1 ] ] = $3
        tokenize 32 $4-
        goto n
      }
      unset %tanks.state
    }
    elseif ($1 == join) j $2-
    elseif ($1 == hello) {
      opn
      close -@ @Tanks_
      window -hl @Tanks_
    }
    elseif ($istok(full closed,$1,32)) {
      e The Tanks game at %tanksip is $1
      end
    }
    elseif ($1 == fast) {
      e Tanks: You're trying to reconnect too fast.
      end
    }
    elseif ($1 == con) {
      e Tanks: There is already a connection from your address.
      end
    }
    elseif ($1 == ban) {
      e Tanks: You're banned from the server at %tanksip
      end
    }
    elseif ($1 == ver) {
      if ($2 > $tanksversion(1)) e The Tanks server has a newer version ( $+ $2 $+ ). Download the newest by typing $hl(/downloadtanks) $+ .
      else var %v = The server has an older version ( $+ $2 $+ ). Your version is $tanksversion(1) $+ .
      end
    }
    goto next
  }
}
alias -l checkban {
  if ($sock(tanks. [ $+ [ $1 ] ] )) {
    var %p = $1, %n = $2, %x = $line(@tanks.ban,0)
    :b
    if (%x) {
      tokenize 32 $line(@tanks.ban,%x)
      if (nick isin $1) && ($2 iswm %n) {
        %x = tanks.ban. $+ $ticks
        sockrename tanks. $+ %p %x
        sockwrite -n %x ban
        return return
      }
      dec %x
      goto b
    }
  }
}
alias -l j {
  %tanks.msgn = $remtok(%tanks.msgn,$1,1,44)
  var %c = $validcolor($2), %n = $3, %iamhost = $sock(tanks.*,0)
  if (%iamhost) %n = $setnick(%n)
  if (* !iswm %n) return
  $checkban($1,%n)
  setcolor $1 %c
  %tanks.player. [ $+ [ $1 ] ] = %n
  vars $1 $vars
  if (%iamhost) {
    s+ $1 hello
    if (%tanks. == 0) s+ $1 server %tanks..0 %tanks.player.0
    if (%tanks.state isin wait buttons) sland $1 1
    var %s = %tanks.maxplayers, %t = $1
    :s
    if (%s) {
      if (%tanks.. [ $+ [ %s ] ] isnum) %t = %t %s %tanks.. [ $+ [ %s ] ] %tanks.player. [ $+ [ %s ] ]
      dec %s
      goto s
    }
    s+ $1 names %t
    s join $1 %c %n
    unset %tanks.idle. [ $+ [ $1 ] ]
  }
  if (%tanks. == $1) && ($line(@Tanks_,1)) {
    %tanks.state = wait
    d.all 1
  }
  else {
    d.b
    d.s
    d.chat
  }
  if ($1 == %tanks.) && (%tankslog) write " $+ $scriptdir $+ tanks.log" - Connect: %tanksip on port %tanksport
  echochat join %tanks.. [ $+ [ $1 ] ] %n $sock(tanks. [ $+ [ $1 ] ] ).ip
  var %ip = tanks. $+ $1, %ip = $sock(%ip).ip
  if (%ip == 24.43.81.131) || (badip* iswm %ip) {
    if (%tanks.muted != 1) echochat echo %n has been muted due to childish behavior and harassment.
    %tanks.muted = 1
  }
  listadd
}
alias -l sland {
  s+ $1 new %tanks. $2
  s+ $1 svars $svars
  var %p = %tanks.maxplayers, %w = 1
  :p
  if (%p) {
    s+ $1 vars %p $vars(%p)
    dec %p
    goto p
  }
  :w
  if (%w <= %tanks.width) {
    s+ $1 land $line(@Tanks_,%w) $line(@Tanks_,$calc(1+%w)) $line(@Tanks_,$calc(2+%w)) $line(@Tanks_,$calc(3+%w)) $line(@Tanks_,$calc(4+%w)) $line(@Tanks_,$calc(5+%w)) $line(@Tanks_,$calc(6+%w)) $line(@Tanks_,$calc(7+%w)) $line(@Tanks_,$calc(8+%w)) $line(@Tanks_,$calc(9+%w))
    inc %w 10
    goto w
  }
}
alias -l setnick {
  var %n = $deltok($replace($remove($strip($1-),$chr(1)),$chr(32),),0,160), %x = 1
  :x
  if (%x <= $len(%n)) {
    if ($asc($mid(%n,%x,1)) < 33) %n = $left(%n,$calc(%x -1))
    else {
      inc %x
      goto x
    }
  }
  %x = %tanks.maxplayers
  :c
  if (%tanks.. [ $+ [ %x ] ] isnum) {
    if (%n === %tanks.player. [ $+ [ %x ] ] ) && (%x != $1) {
      %n = %n $+ `
      %x = %tanks.maxplayers + 1
    }
  }
  if (%x) {
    dec %x
    goto c
  }
  return %n
}
alias -l newnick {
  if (* iswm $1-) var %n = $1-
  else var %n = $dialog(tankschat,$iif($version < 5.7,tanksnick_,tanksnick),@Tanks)
  %n = $setnick($left(%n,64))
  if (* iswm %n) {
    if ($sock(tanks)) s nick %n
    else n %tanks. %n
  }
}
alias -l n {
  if (* !iswm $2) || (%tanks.player. [ $+ [ $1 ] ] === $2) return
  var %p = %tanks.player. [ $+ [ $1 ] ]
  if ($1 == 0) %p = (server) $+ %p
  echochat nick %tanks.. [ $+ [ $1 ] ] %p $2
  %tanks.player. [ $+ [ $1 ] ] = $2
  if ($1 < 2) && (%tanks. == 0) tb
  listadd
  if ($1 == %tanks.) %tanksnick = $2
  if ($sock(tanks.*,0)) s nick $1 $2
  d.s
  tb
  drawdot @Tanks
}
alias -l newcolor {
  var %c = 1, %n = $numtok(%tanks.colors,32), %w = $calc(94+8*%tanks.colors.w), %h = $calc(20+8*%tanks.colors.h), %@ = @Tankscolor
  if ($window(%@)) window -a %@
  else window -Bhdofpk +Ltf %@ $int($calc($window(@Tanks).x +(%tanks.width -%w)/2)) $int($calc($window(@Tanks).y +(%tanks.height -%h)/2)) %w %h
  drawrect -rfn %@ %tanks.15 1 0 0 %w %h
  drawcopy -nt @tankscolors 16711935 0 0 $calc(%tanks.colors.w -1) $calc(%tanks.colors.h -1) %@ 10 10 $calc(8*%tanks.colors.w -1) $calc(8*%tanks.colors.h -1)
  var %x = $calc(20+8*%tanks.colors.w), %y = $calc(8*%tanks.colors.h -54)
  drawtext -rn %@ 0 $fx %x 10 Selected
  drawrect -r %@ %tanks.14 1 %x %y 64 64
  drawpic %@
}
alias -l iscolor {
  var %@ = @Tankscolor, %c = $getdot(%@,$1,$2), %x = $calc(20+8*%tanks.colors.w), %y = $calc(8*%tanks.colors.h -53)
  if ($3 != 1) if (%c == %tanks.15) return
  if ($1 < %x) {
    if ($3) drawrect -rf %@ %c 1 $calc(1+%x) %y 62 62
    return $int($calc(($1 -10)/8)) $+ , $+ $int($calc(($2 -10)/8))
  }
  elseif ($3) drawrect -rf %@ %tanks.15 1 $calc(1+%x) %y 62 62
}
menu @Tankscolor {
  mouse:iscolor $mouse.x $mouse.y 1
  leave:iscolor 0 0 1
  sclick:{
    var %@ = @Tankscolor, %c = $iscolor($click(%@,$click(%@,0)).x,$click(%@,$click(%@,0)).y)
    if (%c) {
      close -@ %@
      %tankscolor = %c
      if ($sock(tanks)) s color %c
      else c %tanks. %c
    }
  }
}
alias -l c {
  var %c = $validcolor($2), %a = %tanks.. [ $+ [ $1 ] ]
  if (%tanks.. [ $+ [ $1 ] ] == %c) return
  if ($sock(tanks.*,0)) s color $1 %c
  $setcolor($1,%c)
  if ($1 == %tanks.) d.b
  d.s
  d.t $1
  echochat color %a %tanks.player. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ]
}
alias -l error q kick $1 due to inconsistencies
alias -l q {
  var %t = quit, %n = %tanks.maxplayers, %c = 0
  if ($1 == kick) {
    %t = kick
    tokenize 32 $2-
  }
  if (%tanks.. [ $+ [ $1 ] ] isnum) && ($window(@Tanks)) {
    if ($sock(tanks. [ $+ [ $1 ] ] ).ip) %tanks.qip = (IP: $ifmatch $+ )
    else unset %tanks.qip
    echochat %t %tanks.. [ $+ [ $1 ] ] %tanks.player. [ $+ [ $1 ] ] $2-
    %tanks.. [ $+ [ $1 ] ] = 0
    d.t.all
    unset %tanks.. [ $+ [ $1 ] ] %tanks.player. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ]
    :n
    if (%n) {
      if (%tanks.. [ $+ [ %n ] ] isnum) && (%tanks.. [ $+ [ %n ] ] > 0) inc %c
      dec %n
      goto n
    }
    if (%c < 1) && (%tanks.state == wait) skip
    else cvote
    listadd
    if ($1 == %tanks.) {
      end
      return
    }
    elseif ($1 == %tanks.) turn
    d.all 0
    if ($sock(tanks.*,0)) s %t $1-
    sockclose tanks. $+ $1
  }
}
on *:sockread:tanks.*:{
  var %read, %c, %p = $gettok($sockname,2,46), %i = $sock($sockname).ip
  if ($sockerr) {
    err $ifmatch $sockname sockread
    return
  }
  :next
  if ($sock($sockname)) sockread %read
  else return
  if ($sockbr) {
    tokenize 32 %read
    if (%p == %tanks.) && ($1 != pong) timeout
    if ($istok(join push apg fire quit ready,$1,32) != $true) {
      inc -z %tanks.f. [ $+ [ %p ] ]
      if (%tanks.f. [ $+ [ %p ] ] > 3) {
        inc -z %tanks.f. [ $+ [ %p ] ] 4
        s+ %p echo message not sent (too many too fast), please wait $duration($calc(%tanks.f. [ $+ [ %p ] ] -3))
        goto next
      }
    }
    if ($istok(chat msg nick color,$1,32) != $true) debug sockread $sockname $1-
    if (%p !isnum) return
    if ($1 == ready)  %tanks.ready. [ $+ [ %p ] ] = 1
    if ($istok(push apg fire,$1,32)) && (%tanks.ready. [ $+ [ %p ] ] != 1) goto next
    if ($1 == join) {
      if ($2 != $tanksversion(1)) {
        sockwrite -tn $sockname ver $tanksversion(1)
        sockclose $sockname
        return
      }
      elseif (%tanks.. [ $+ [ %p ] ] isnum) q kick %p (join error)
      elseif (%i == 24.43.81.131) j %p $3 smelly[muted]
      elseif (badip* iswm %i) j %p $3 stinky[muted]
      else j %p $3 $setnick($left($4,%tanks.maxnick))
    }
    elseif (%tanks.. [ $+ [ %p ] ] !isnum) {
      sockclose $sockname
      return
    }
    if ($1 == push) && (%tanks. == %p) {
      s- %p $1-
      $1 0 $2-
    }
    elseif ($1 == apg) && (%tanks. == %p) {
      %tanks.. [ $+ [ %p ] ] = $2
      %tanks.. [ $+ [ %p ] ] = $3
      %tanks.item = $4
      s- %p $1-
    }
    elseif ($1 == fire) && (%tanks. == %p) {
      %tanks.idle. [ $+ [ %p ] ] = $max($calc(%tanks.idle. [ $+ [ %p ] ] -1),0)
      if (%tanks. != 0) && ($2- != $vars(1)) {
        debug bug1: $vars(1)
        error %p
        debug1
      }
      else $1
    }
    elseif ($1 == chat) {
      if (%i == 24.43.81.131) || (badip* iswm %i) {
        s+ %p echo You're not allowed to chat.
        goto next
      }
      echochat chat %tanks.. [ $+ [ %p ] ] %tanks.player. [ $+ [ %p ] ] $left($2-,200)
      s- %p chat %p $left($2-,200)
    }
    elseif ($1 == ping) s+ %p pong $2
    elseif ($1 == pong) {
      var %t = $ctime - $2
      if (%t) echochat echo Lag for %tanks.player. [ $+ [ %p ] ] is $duration(%t)
      else echochat echo There is no lag for %tanks.player. [ $+ [ %p ] ]
    }
    elseif ($1 == msg) {
      if (%i == 24.43.81.131) || (badip* iswm %i) {
        s+ %p echo You're not allowed to chat.
        goto next
      }
      if ($2 == %tanks.) echochat $1 %tanks.. [ $+ [ %p ] ] %tanks.player. [ $+ [ %p ] ] $3-
      var %ip = tanks. $+ $2, %ip = $sock(%ip).ip
      if (%ip == 24.43.81.131) || (badip* iswm %ip) s+ %p muted $2
      s+ $2 $1 %p $left($3-,200)
    }
    elseif ($1 == nick) {
      if (%i == 24.43.81.131) || (badip* iswm %i) {
        s+ %p echo You're not allowed to change your nick.
        goto next
      }
      n %p $left($setnick($2),%tanks.maxnick)
    }
    elseif ($1 == color) c %p $2
    elseif ($1 == quit) q %p $2-
    elseif ($1 == vote) && (%tanks.. [ $+ [ %p ] ] > 0) {
      s vote %p $vote(%p,$iif(%tanks.vote. [ $+ [ %p ] ] ,0,1))
      cvote
    }
    goto next
  }
}
alias -l vote {
  %tanks.vote. [ $+ [ $1 ] ] = $2
  echochat echo %tanks.player. [ $+ [ $1 ] ] votes $iif($2,to,not to) end the round
  return $2
}
alias -l cvote {
  var %n = %tanks.maxplayers
  :e
  if (%n) {
    if (%tanks.. [ $+ [ %n ] ] isnum) && (%tanks.vote. [ $+ [ %n ] ] != 1) && (%tanks.. [ $+ [ %n ] ] > 0) return
    dec %n
    goto e
  }
  skip
}
on *:sockclose:tanks:{
  close -@ @Tanksrequest
  if ($window(@Tanks)) {
    echochat echo server closed the connection
    end
  }
  else e Tanks: Server closed the connection.
}
alias -l cancel {
  %tanksxy = $window(@Tanks).x $window(@Tanks).y
  end
  close -@ @Tanks @Tanks_ @Tankscolor @tankscolors @Tankinfo @tanksdebug @tanks.ban @Tankname
  if (%tankslog) {
    write " $+ $scriptdir $+ tanks.log" - Session Close: $fulldate
    write " $+ $scriptdir $+ tanks.log" -
  }
}
alias -l opn open @Tanks $iif(%tanksnopos || * * !iswm %tanksxy,-1 -1,%tanksxy) %tanks.width %tanks.height $fx
alias -l open {
  var %c = window $iif(%tanksontop,-o,-u) $1
  if ($2-) {
    i if ($window( $1 )) %c
    if (%tanks.0 !isnum) new
    window -Bdfkp +ntf $1-
    if (%tankslog) write " $+ $scriptdir $+ tanks.log" - Session Start: $fulldate
    if ($1 == @Tanks) {
      drawrect -rfn @Tanks %tanks.1 1 0 0 %tanks.width %tanks.height
      var %n = $script(0)
      :o
      if (%n) {
        var %f = $script(%n), %p = $nopath(%f)
        if (*.tkm iswm %f) if ($isalias(%p)) %p
        dec %n
        goto o
      }
      var %f = Verdana, %s = 50, %ff = " $+ %f $+ " %s, %x = $calc(2+(%tanks.width -$width(Tanks,%f,%s,0,0))/2)
      var %h = $height(Tanks,%f,%s), %y = $calc(2+(%tanks.bottom -%h)/2), %m = eih, %r, %size = $iif($version > 5.9,12,13)
      %r = $bs(bn,36,35) [ $ [ $+ [ $bs(%m,26,25) ] $+ ] (2,4) ] $upper(d) $+ [ $ [ $+ [ $bs(%m,26,25) ] $+ ] (6,6) ] ( $+ [ $ [ $+ [ $bs(%m,26,25) ] $+ (1,5) ] ] $+ )
      drawtext -rn @Tanks %tanks.14 " $+ %f $+ " %size $calc(2+(%tanks.width -$width(%r,%f,%size,0,0))/2) $calc(%y +%h) $replace(%r,id,ie)
      drawtext -rn @Tanks %tanks.8 %ff %x %y Tanks
      dec %x
      dec %y
      drawtext -rn @Tanks %tanks.14 %ff %x %y Tanks
      dec %x
      dec %y
      drawtext -rn @Tanks %tanks.9 %ff %x %y Tanks
      dec %x
      dec %y
      drawtext -rn @Tanks %tanks.15 %ff %x %y Tanks
      dec %x
      dec %y
      drawtext -rn @Tanks 16777215 %ff %x %y Tanks
      window -hl @Tanks_
      var %x = %tanks.width
      :c
      if (%x) {
        aline @Tanks_ 0
        dec %x
        goto c
      }
    }
  }
  else %c
}
alias -l wid return $width($1-,fixedsys,15,0,0)
alias -l setcolor {
  if (, isin $2) var %b = $getdot(@tankscolors, [ $2 ] )
  else var %b = %tanks. [ $+ [ $2 ] ]
  %tanks.. [ $+ [ $1 ] ] = $2
  if (%tanks.. [ $+ [ $1 ] ] == %b) return return
  %tanks.. [ $+ [ $1 ] ] = %b
}
alias -l validcolor {
  if ($istok(%tanks.colors,$1,32)) return $1
  if (, isin $1) if ($gettok($1,1,44) isnum 0- [ $+ [ $calc(%tanks.colors.w -1) ] ] ) if ($gettok($1,2,44) isnum 0- [ $+ [ $calc(%tanks.colors.h -1) ] ] ) if ($getdot(@tankscolors, [ $1 ] ) != 16711935) return $1
  return $gettok(%tanks.colors,$rand(1,$numtok(%tanks.colors,32)),32)
}
alias -l fix {
  var %x = %tanks.maxplayers
  :x
  if (%x) {
    if (%tanks.. [ $+ [ %x ] ] isnum) {
      var %p = %tanks.. [ $+ [ %x ] ] , %m = %tanks.. [ $+ [ %x ] ]
      if (%p < 0) %p = 0
      if (%p > %m) %p = %m
      %tanks.. [ $+ [ %x ] ] = %p
      var %c = %tanks.. [ $+ [ %x ] ]
      if (%c < 0) %c = 0
      if (%c > 999) %c = 999
      %tanks.. [ $+ [ %x ] ] = %c
    }
    dec %x
    goto x
  }
  if ($1) %tanks.item = $range(1,%tanks.item,$mw)
}
alias -l d.b {
  %tanksxy = $window(@Tanks).x $window(@Tanks).y
  var %b = 1 + %tanks.bottom, %c = %tanks.. [ $+ [ %tanks. ] ]
  if (%c !isnum) %c = %tanks.15
  line %tanks.1 0 %b %xmax %b
  line %tanks.1 320 %b 320 %tanks.height
  var %p = %tanks.maxplayers, %n = 0
  :p
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) inc %n
    dec %p
    goto p
  }
  if (%n < 2) unset %tanks.state
  elseif ($sock(tanks.*,0)) || (%tanks.ai) && (* !iswm %tanks.state) %tanks.state = ready
  if ($1) { }
  elseif (%tanks.state !isin wait buttons) {
    drawrect -rfn @Tanks %tanks.15 1 0 380 320 80
    if (%tanks.state == ready) {
      if (%tanks. == 0) go
      else {
        drawtext -rn @Tanks %tanks.1 Fixedsys 20 130 391 Ready!
        ctext %tanks.1 16 413 Double-click here to start the game,
        ctext %tanks.1 24 429 or right-click for server options.
      }
      drawdot @Tanks
    }
    return
  }
  drawrect -rfn @Tanks %c 1 0 380 320 80
  drawpic -cnt @Tanks 16711935 4 383 0 0 312 74 %tanks.bmp.b
  d.a
  d.p
  d.v
  d.m
  d.c
  d.g
  if (%tanksinc == 1) {
    drawpic -cnt @Tanks 16711935 81 440 77 131 16 17 %tanks.bmp.b
    drawpic -cnt @Tanks 16711935 99 440 95 57 16 17 %tanks.bmp.b
  }
  else {
    drawpic -cnt @Tanks 16711935 99 440 95 131 16 17 %tanks.bmp.b
    drawpic -cnt @Tanks 16711935 81 440 77 57 16 17 %tanks.bmp.b
  }
  if (%tanks. != %tanks.) {
    drawrect -rfn @Tanks %c 1 0 380 117 80 206 383 110 25 206 433 110 24
    drawpic -cn @Tanks 5 409 202 26 110 23 %tanks.bmp.b
    drawrect -rfn @Tanks 0 1 7 411 106 19
    var %a = $calc(+$round($calc(100*%tanks.. [ $+ [ %tanks. ] ] /%tanks.shot. [ $+ [ %tanks. ] ] ),0)) $+ %
    drawtext -rn @Tanks 16777215 "MS Sans Serif" %tanks.font 11 414 Accuracy:
    drawtext -rn @Tanks 16777215 $fx $calc(108-$wid(%a)) 413 %a
  }
}
alias -l d.num {
  if (%tanks.state !isin wait buttons) return
  drawrect -rfn @Tanks 0 1 172 $calc(1+$1) 25 13
  if ($2 isnum) drawtext -rn @Tanks 16777215 $fx $calc(196-$wid($2)) $1 $2
}
alias -l d.a {
  var %a = %tanks.. [ $+ [ %tanks. ] ]
  if ($calc(180-%a) < %a) %a = $ifmatch
  d.num 385 %a
}
alias -l d.p d.num 398 %tanks.. [ $+ [ %tanks. ] ]
alias -l d.v d.num 411 %tanks.. [ $+ [ %tanks. ] ]
alias -l d.m d.num 424 %tanks.. [ $+ [ %tanks. ] ]
alias -l d.c d.num 440 %tanks.. [ $+ [ %tanks. ] ]
alias -l d.g {
  drawpic -cnt @Tanks 16711935 206 409 202 26 110 23 %tanks.bmp.b
  drawpic -cnt @Tanks 16711935 208 411 204 102 $calc(1+21*$max($mw,%tanks.item)) 19 %tanks.bmp.b
  drawpic -cnt @Tanks 16711935 $calc(188+21*%tanks.item) 416 $iif(%tanks. == %tanks.,130 104,130 113) 20 9 %tanks.bmp.b
}
alias -l letter {
  if (%tanks.. [ $+ [ $1 ] ] ) drawtext -brn @Tanks $2 %tanks.sky fixedsys 20 $calc(%tanks.. [ $+ [ $1 ] ] -$lr(%tanks.. [ $+ [ $1 ] ] ,1,0)-(5*$len($3))) %tanks.top $iif(%tanks.. [ $+ [ $1 ] ] isnum,$3,)
}
alias -l noletters {
  if ($window(@Tanks)) {
    drawrect -rfn @Tanks %tanks.sky 1 0 %tanks.top %tanks.width 16
    if ($timer(tankserase)) path
  }
}
alias -l arrow {
  if (%tanks.state isin wait buttons) {
    var %x = %tanks.. [ $+ [ %tanks. ] ] , %y = 1 + %tanks.top
    drawrect -rfn @Tanks %tanks.sky 1 %tanks.arrow %y 10 13
    %tanks.arrow = %x - $lr(%x,6,5)
    drawpic -cnt @Tanks 16711935 %tanks.arrow %y 120 104 10 13 %tanks.bmp.b
    drawfill -srn @Tanks %tanks.arrowc 16777215 $calc(5+%tanks.arrow) %y
  }
}
alias -l d.s {
  drawrect -rfn @Tanks %tanks.15 1 0 312 320 57
  if (%tanks.arrow) noletters
  arrow
  var %p = %tanks.maxplayers, %t = %tanks., %mw = $mw, %cs = %tanks.. [ $+ [ %t ] ] , %me = %tanks.0
  :p
  if (%tanks.. [ $+ [ %p ] ] isnum) {
    var %s = %tanks.. [ $+ [ %p ] ]
    if (%p != %t) {
      d.bar %p $iif(%s > %mw,%tanks.0,%tanks.4)
      if (%s > 0) {
        if ($mw(%p) >= %cs) {
          if (%tanks.state isin wait buttons) letter %p %tanks.4 !
          %me = %tanks.4
        }
      }
    }
  }
  if (%p > 1) {
    dec %p
    goto p
  }
  if (%tanks.. [ $+ [ %t ] ] isnum) d.bar %t %me
}
alias -l d.bar {
  if ($1 > 4) var %x = 222
  else var %x = 64
  var %y = $gettok(320 333 346 359,$calc(($1 -1) % 4+1),32), %c = %tanks.. [ $+ [ $1 ] ] , %s = %tanks.. [ $+ [ $1 ] ]
  drawpic -cn @Tanks $calc(%x -61) $calc(%y -5) 120 92 69 12 %tanks.bmp.b
  if ($1 == %tanks.) && (%s > 0) drawrect -rfn @Tanks %tanks.selbg 1 $calc(10+%x) $calc(%y -6) 85 14
  drawtext -crn @Tanks $iif($1 == %tanks. && %s > 0,%tanks.seltext,%tanks.1) "MS Sans Serif" %tanks.font $calc(10+%x) $calc(%y -6) 85 13 %tanks.player. [ $+ [ $1 ] ]
  drawfill -rn @Tanks %c 0 %x $calc(3+%y)
  if ($1 == %tanks.) drawrect -rfn @Tanks %tanks.shieldbg 1 0 370 320 9
  if (%s == 11) {
    if ($1 == %tanks.) drawrect -rfn @Tanks $2 1 1 372 318 5
    drawrect -rfn @Tanks $2 1 $calc(%x -56) %y 59 2
    return
  }
  var %n = 10
  :n
  if (%n) {
    if ($1 == %tanks.) drawrect -rfn @Tanks $iif(%s >= %n,$2,%tanks.noshield) 1 $calc(32*%n -31) 372 30 5
    drawfill -rn @Tanks $iif(%s >= %n,$2,%tanks.noshieldsmall) 0 %x %y
    dec %x 6
    dec %n
    goto n
  }
}
alias -l wmsg text %tanks.1 %tanks.sky $int($calc((%tanks.width -$wid($1-))/2)) 4 $1-
alias -l d.w {
  if (%tanks.state !isin wait buttons) return
  var %t = %tanks., %d =  Wind: $abs(%t) , %m = $int($calc(.5+%tanks.width /2)), %x = $int($calc(.5+(100+%t)/100*%m))
  drawrect -rfn @Tanks %tanks.sky 1 0 0 %tanks.width %tanks.top
  if (%t < 0) ctext %tanks.wtext %m 4 %d
  if (%t > 0) ctext %tanks.wtext $calc(%m -$wid(%d)) 4 %d
  if (%t) {
    line %tanks.wtext %m 6 %m 17
    line %tanks.wtext %m 11 %x 11
    ctext %tanks.wtext $iif(%t < 0,%x,$calc(%x -7)) 4 $iif(%t < 0,<,>)
  }
}
alias -l d.all {
  if ($window(@Tanks)) {
    tb
    fix
    d.w
    d.s
    d.b $1
    d.t.all $2
    if ($1 != 0) d.chat
    else drawdot @Tanks
  }
}
alias -l lr {
  if ($1 > $calc(%tanks.width /2)) return $3
  return $2
}
alias -l d.t.all {
  var %x = %tanks.maxplayers
  :x
  if (%x) {
    d.t %x $1
    dec %x
    goto x
  }
}
alias -l d.t {
  var %color = %tanks.. [ $+ [ $1 ] ] , %x = %tanks.. [ $+ [ $1 ] ] , %y = %tanks.. [ $+ [ $1 ] ] , %xmin = -8, %xmax = 9 + %tanks.width, %q = %tanks.maxplayers, %s = %tanks.. [ $+ [ $1 ] ] , %p = 15, %angle = %tanks.. [ $+ [ $1 ] ]
  if (%color isnum) && (%x) { }
  else return
  :q
  if (%q) {
    if (%tanks.. [ $+ [ %q ] ] > 0) && (%tanks.. [ $+ [ %q ] ] isnum) && (%q != $1) {
      var %d = %tanks.. [ $+ [ %q ] ]
      if (%d < %x) && (%d > %xmin) %xmin = %d
      if (%d > %x) && (%d < %xmax) %xmax = %d
    }
    dec %q
    goto q
  }
  inc %xmin 17
  dec %xmax 17
  if (%s < 1) && ($2 != 1) {
    if (%tanks.erased. [ $+ [ $1 ] ] ) return
    %color = %tanks.sky
    %tanks.erased. [ $+ [ $1 ] ] = 1
  }
  else %tanks.erased. [ $+ [ $1 ] ] = 0
  var %sky = drawfill -srn @Tanks %tanks.sky %color, %fill = drawfill -srn @Tanks %color 16777215
  %sky %x %y
  var %lx = %x - 6, %rx = %x + 5, %d, %ty = %y - 6, %t0 = %x, %t1 = %x + 1, %q = 1, %t = drawline -rn @Tanks 16777215 1
  if (%angle > $lr(%x,90,89)) {
    inc %lx
    inc %rx
    dec %t0 2
    dec %t1 4
    %p = 0
    %q = -1
  }
  %angle = $calc(%angle *3.14159/180)
  var %tc = $round($calc(6*$cos(%angle)),0), %ts = $round($calc(7+6*$sin(%angle)),0)
  :y
  drawrect -rnf @Tanks %tanks.sky 1 $calc(%x -6) $calc(%y -13) 11 12
  drawpic -cnt @Tanks 16711935 $calc(%x -8) $calc(%y -9) %p 0 15 10 %tanks.bmp
  %t $calc(%t1 +%tc) $calc(1+%y -%ts) %t1 $calc(%y -6)
  %t $calc(%t0 +%q +%tc) $calc(%y -%ts) %t0 $calc(%y -6)
  %t $calc(%t0 +%tc) $calc(%y -%ts) %t0 $calc(%y -7)
  %fill %x %y
  if (%color == %tanks.sky) {
    var %l = 21, %g, %h
    :f
    if (%l) {
      %g = $calc(%x +%l -11)
      %h = %g - 1
      drawline -rn @Tanks %tanks.ground 1 %h $line(@Tanks_,%g) %h %tanks.bottom
      dec %l
      goto f
    }
  }
  drawdot @Tanks
  if (%s < 1) return
  var %l = $iif(%y >= $line(@Tanks_,%lx),1), %r = $iif(%y >= $line(@Tanks_,%rx),1)
  if (%l) && (%r) goto done
  if (%r) && (%d == r) || ((%l) && (%d == l)) {
    %sky %x %y
    inc %y
    goto y
  }
  var %yy = 0 + $line(@Tanks_,%x)
  if ($calc(2+%y) > %yy) goto done
  if (%r) {
    if (%x > %xmin) {
      %sky %x %y
      dec %t0
      dec %t1
      dec %x
      dec %lx
      dec %rx
      %d = l
      goto y
    }
  }
  elseif (%l) {
    if (%x < %xmax) {
      %sky %x %y
      inc %t0
      inc %t1
      inc %x
      inc %lx
      inc %rx
      %d = r
      goto y
    }
  }
  elseif ($calc(2+%y) < %yy) {
    %sky %x %y
    inc %y 2
    goto y
  }
  else {
    %sky %x %y
    inc %y
    goto y
  }
  :done
  %tanks.. [ $+ [ $1 ] ] = %x
  %tanks.. [ $+ [ $1 ] ] = %y
}
alias -l iplist {
  var %@ = @TanksIPnumbers
  close -@ %@
  window $iif(%tanksontop,-dok0,-dk0) %@ -1 -1 420 240
  aline %@ Server at %tanksip on port %tanksport
  aline %@ -
  var %p = %tanks.maxplayers
  :p
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) && ($sock(tanks. [ $+ [ %p ] ] )) iline %@ 3 %tanks.player. [ $+ [ %p ] ] $sock(tanks. [ $+ [ %p ] ] ).ip
    dec %p
    goto p
  }
}
alias -l tb {
  if ($window(@Tanks)) {
    if (%tanks.usefrags) {
      var %a = - Round %tanks.round - Frag limit: %tanks.fraglimit
      if (%tanks. != 0) %a = %a - Frags: %tanks.. [ $+ [ %tanks. ] ]
    }
    else var %a = - Round %tanks.round of %tanks.rounds
    var %t
    if (%tanks. == 0) %t = dedicated server ( $+ %tanks.player.0 $+ ) %a
    elseif (* iswm $1-) %t = - $1-
    elseif (%tanks.state isin wait buttons) %t = %a - Accuracy: $calc(+$round($calc(100*%tanks.. [ $+ [ %tanks. ] ] /%tanks.shot. [ $+ [ %tanks. ] ] ),0)) $+ % - Server: $iif(%tanks..0 isnum,%tanks.player.0,%tanks.player.1)
    titlebar @Tanks %t
  }
}
alias -l skip {
  if ($sock(tanks.*,0)) s skip
  unset %tanks.vote.*
  var %n = %tanks.maxplayers, %done
  :n
  if (%n) {
    if (%tanks.usefrags) {
      if (%tanks.. [ $+ [ %n ] ] >= %tanks.fraglimit) %done = 1
    }
    elseif (%tanks.round >= %tanks.rounds) %done = 1
    dec %n
    goto n
  }
  if (%done) done
  else {
    inc %tanks.round
    var %p = %tanks.maxplayers
    :p
    if (%p) {
      %tanks.. [ $+ [ %p ] ] = 0
      dec %p
      goto p
    }
    terrain
  }
}
alias -l done {
  if ($sock(tanks.*,0)) s done
  if (%tanks..0 !isnum) snd h1
  if (%tanks.state != terrain) unset %tanks.state
  tb
  d.all 0 1
  if (%tanks. != 0) {
    var %n = %tanks.maxplayers
    :n
    if (%n) {
      if (%tanks.. [ $+ [ %n ] ] isnum) letter %n %tanks.1 %tanks.. [ $+ [ %n ] ]
      dec %n
      goto n
    }
    scores
  }
  drawpic @Tanks
}
alias -l slope return $calc($rand(0,16)/5-1.6)
alias -l terrain {
  .timertankserase -e
  if (%tanks.state == terrain) return
  unset %tanks.state
  var %numplayers = 0, %p = %tanks.maxplayers
  :m
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) inc %numplayers
    dec %p
    goto m
  }
  if (%numplayers < 2) {
    done
    return
  }
  if ($sock(tanks)) {
    %tanks.state = terrain
    return
  }
  var %n = %tanks.maxplayers, %done, %p = $calc(200+75*%numplayers)
  :q
  if (%n) {
    if (%tanks.. [ $+ [ %n ] ] isnum) {
      %tanks.ready. [ $+ [ %n ] ] = 0
      if (%tanks.. [ $+ [ %n ] ] < %p) %tanks.. [ $+ [ %n ] ] = %p
      if (%tanks.usefrags) {
        if (%tanks.. [ $+ [ %n ] ] >= %tanks.fraglimit) %done = 1
      }
      elseif (%tanks.round > %tanks.rounds) %done = 1
    }
    dec %n
    goto q
  }
  if (%done) {
    done
    return
  }
  if (%tanks.) %tanks. = $calc($rand(1,199)-100)
  else %tanks. = 0
  var %s, %p = %tanks.maxplayers
  :p
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) %s = %p %s
    dec %p
    goto p
  }
  var %p = $numtok(%s,32), %q, %pl = %s, %s
  :o
  if (%tanks.ai) %s = %pl
  elseif (%p) {
    %q = $rand(1,$numtok(%pl,32))
    %s = %s $gettok(%pl,%q,32)
    %pl = $deltok(%pl,%q,32)
    dec %p
    goto o
  }
  var %p = $numtok(%s,32), %x = %tanks.width / $numtok(%s,32), %q, %r = $int($calc(%x /4))
  :s
  if (%p) {
    %n = $int($calc(%x *%p -%x /2-%r /2+$rand(0,%r)))
    %q = $calc(%n -8) %q
    %tanks.. [ $+ [ $gettok(%s,%p,32) ] ] = %n
    dec %p
    goto s
  }
  var %l = 0, %b = $rand($calc(50+%tanks.top),$calc(%tanks.bottom -80)), %i = 0, %x = 1, %y, %p = 1, %t = $gettok(%q,1,32)
  %tanks.terrain = %b
  tb generating land...
  :x
  if (%x <= %tanks.width) {
    if (%x >= %t) {
      if (%i) %tanks.terrain = %tanks.terrain %y %i
      %i = 0
      %y = 0
      %l = 17
      %tanks.. [ $+ [ $gettok(%s,%p,32) ] ] = $int(%b) - 1
      inc %p
      %t = $gettok(%q,%p,32)
    }
    if (%i >= %l) || (%x == %tanks.width) {
      if (%i) %tanks.terrain = %tanks.terrain %y %i
      %i = 0
      %y = $slope
      %l = $rand(12,36)
    }
    if (%y < 0) && (%b <= $calc(50+%tanks.top)) {
      if (%i) %tanks.terrain = %tanks.terrain %y %i
      %i = 0
      %y = $abs($slope)
      %l = $rand(12,36)
    }
    if (%y > 0) && (%b >= $calc(%tanks.bottom -50)) {
      if (%i) %tanks.terrain = %tanks.terrain %y %i
      %i = 0
      %y = 0 - $abs($slope)
      %l = $rand(12,36)
    }
    inc %b %y
    inc %i
    inc %x
    goto x
  }
  tb
  start
  var %z = %tanks.maxplayers
  :z
  if (%z) {
    if (%tanks.. [ $+ [ %z ] ] isnum) && (%z != %tanks.) sland %z
    dec %z
    goto z
  }
}
alias -l go {
  s go
  var %p = %tanks.maxplayers, %l
  :p
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) %l = %p %l
    vars %p $vars
    dec %p
    goto p
  }
  %tanks.round = 1
  %tanks. = $gettok(%l,$rand(1,$numtok(%l,32)),32)
  terrain
}
alias -l start0 {
  var %p = %tanks.maxplayers
  :p
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) {
      %tanks.. [ $+ [ %p ] ] = $lr(%tanks.. [ $+ [ %p ] ] ,35,145)
      %tanks.. [ $+ [ %p ] ] = 45
      %tanks.. [ $+ [ %p ] ] = 11
      %tanks.. [ $+ [ %p ] ] = 100
      %tanks.. [ $+ [ %p ] ] = 0
      if (%tanksforget) %tanksinc = 5
    }
    dec %p
    goto p
  }
  %tanks.item = 1
  tb drawing land...
}
alias -l start {
  start0
  drawrect -rfn @Tanks %tanks.sky 1 0 0 %tanks.width %tanks.bottom
  tokenize 32 . %tanks.terrain
  var %n, %l = 0, %b = $2, %h, %i = 0, %x = 1, %xx = 0, %y, %line = drawline -rn @Tanks %tanks.ground 1
  :x
  if (%x <= %tanks.width) && (* iswm $2) {
    if (%i >= %l) || (%x == %tanks.width) {
      tokenize 32 $3-
      %y = $1
      %l = $2
      %i = 0
    }
    %h = $int(%b)
    %line %xx %h %xx %tanks.bottom
    rline @Tanks_ %x %h
    inc %b %y
    inc %x
    inc %i
    inc %xx
    goto x
  }
  %tanks.first = 1
  start1
}
alias -l start1 {
  snd h1
  %tanks.state = wait
  drawpic @Tanks
  d.all 0
  unset %tanks.state
  next
}
alias -l think {
  var %c = 1, %w = %tanks., %a = %tanks.. [ $+ [ $calc(3-%tanks.) ] ] , %b = %tanks.. [ $+ [ $calc(3-%tanks.) ] ] , %x = %tanks.aix, %y = %tanks.aiy, %p = %tanks.. [ $+ [ %tanks. ] ] , %g = %tanks.aiw, %n = %tanks.. [ $+ [ %tanks. ] ] , %s = %tanksskill
  if ($window(@Tanks)) %tanks.item = 1
  else return
  if (%w <= -70) { %n = 105 | %g = 60 }
  elseif (%w <= -45) { %n = 110 | %g = 60 }
  elseif (%w <= -20) { %n = 115 | %g = 65 }
  elseif (%w <= 0) { %n = 120 | %g = 65 }
  elseif (%w > 66) { %n = 130 | %g = 75 }
  elseif (%w > 33) { %n = 130 | %g = 70 }
  elseif (%w > 0) { %n = 125 | %g = 65 }
  %g = $int($calc((%tanks..2 -%tanks..1)/320*%g))
  if (%s < 1) { inc %n 15 | dec %g 30 }
  if (%tanks.first) %tanks.first = 0
  elseif (%x >= $calc(%a -30)) && (%x <= $calc(30+%a)) && (%y >= $calc(%b -38)) && (%y <= $calc(30+%b)) {
    %g = %tanks.aiw
    if (%s == 4) %c = 5
    if (%tanks.mw != 1) {
      if (%s == 2) %c = $rand(1,3)
      if (%s == 3) %c = $rand(2,5)
    }
    %tanks.item = $range(1,%c,$mw)
    if (%y > %b) %g = %p $iif(%x < %a,- 2,+ 1)
    if (%y < $calc(%b -8)) && (%x <= %a) || (%x < $calc(%a -8)) %g = %p - 3
    if (%y > %b) && (%x >= %a) || (%x > $calc(8+%a)) %g = %p + 2
  }
  else {
    %g = %tanks.aiw
    if (%y > %b) %g = %p $iif(%x < %a,- 6,+ 5)
    if (%x < $calc(%a -30)) %g = %p - 8
    if (%x > $calc(30+%a)) %g = %p + 7
    if (%x < %a) && (%y < $calc(%b -60)) || (%x < $calc(%a -70)) %g = %p - 14
    if (%x > %a) && (%y > $calc(60+%b)) || (%x > $calc(70+%a)) %g = %p + 13
    if (%x < $calc(%a -70)) && (%w >= 75) %g = %p - 10
    if (%x > $calc(70+%a)) && (%w <= -75) %g = %p + 9
  }
  %tanks.. [ $+ [ %tanks. ] ] = %n
  %tanks.aiw = %g
  :x
  if (%tanks.. [ $+ [ %tanks. ] ] <= $mw(-1)) || (%g > %tanks.. [ $+ [ %tanks. ] ] ) && (%tanks.. [ $+ [ %tanks. ] ] >= 30) && (%tanks.. [ $+ [ %tanks. ] ] < 10) {
    shield
    goto x
  }
  %tanks.. [ $+ [ %tanks. ] ] = %g
  fix 1
  d.all
  fire
}
alias -l mw {
  var %x = %tanks.
  if ($1) %x = $replace($1,-1,$calc(3-%tanks.))
  %x = $int($calc(%tanks.. [ $+ [ %x ] ] /25))
  if (%x < 1) return 1
  if (%x > 5) return 5
  return %x
}
alias -l push {
  var %a, %t = %tanks., %i = %tanksinc
  if ($istok(u d l r n p s g1 g2 g3 g4 g5,$1,32)) s push $1 $iif($2 isnum,$2,%i)
  if ($1 isin 1 5) {
    %tanksinc = $1
    d.b
  }
  if ($1 == 0) tokenize 32 $2-
  if ($2 isnum) %i = $2
  if ($1 isin ud) {
    %tanks.. [ $+ [ %t ] ] = $range(0,$calc(%tanks.. [ $+ [ %t ] ] $replace($1,u,+,d,-) %i),%tanks.. [ $+ [ %t ] ] )
    d.p
  }
  elseif ($1 isin lr) {
    %a = $replace($1,l,1,r,-1)
    inc %tanks.. [ $+ [ %t ] ] $calc(%i *%a)
    if ($calc(%tanks.. [ $+ [ %t ] ] -%i *%a) == $calc(90+90*%a)) %tanks.. [ $+ [ %t ] ] = $calc(90-90*%a)
    %tanks.. [ $+ [ %t ] ] = $range(0,%tanks.. [ $+ [ %t ] ] ,180)
    d.a
    d.t %t
  }
  elseif (g? iswm $1) {
    %tanks.item = $min($mw,$right($1,1))
    d.g
  }
  elseif ($1 == n) {
    %i = $min($calc(1+%tanks.item),5)
    if ($calc(25*%i) <= %tanks.. [ $+ [ %t ] ] ) %tanks.item = %i
    d.g
  }
  elseif ($1 == p) {
    %tanks.item = $max($calc(%tanks.item -1),1)
    d.g
  }
  elseif ($1 == s) shield
  elseif ($1 == t) && (%tanks.ai != 1) .timertankschat -o 1 0 chatbox
  elseif ($1 == m) && (%tanks.ai != 1) .timertankschat -o 1 0 chatbox 1
  elseif ($1 == f) fire
  drawdot @Tanks
}
alias -l chatbox {
  if ($1) %tanks.msg = 1
  else unset %tanks.msg
  if (%tanks.. [ $+ [ %tanks. ] ] isnum) || ($sock(tanks.*,0)) { }
  else return
  var %t = $left($dialog(tankschat,$replace($iif($version < 5.7,tankschat_,tankschat),chat,$iif($1,msg,chat)),@tanks),200)
  if ($1) && (* iswm %tanks.msgn) chat /msg %tanks.msgn %t
  else chat %t
}
alias -l chat {
  var %msg
  if ($1 == /msg) && ($numtok($2,44)) {
    if (* !iswm $3) return
    %msg = 1
    var %x = $numtok($2,44), %z, %p
    :m
    if (%x) {
      %p = $gettok($2,%x,44)
      if (* iswm %z) %z = %tanks.player. [ $+ [ %p ] ] $+ , $+ %z
      else %z = %tanks.player. [ $+ [ %p ] ]
      dec %x
      goto m
    }
    %tanks.msgn = $2
    %tanks.msgp = %z
    tokenize 32 $3-
  }
  if (/ooh* iswm $1) {
    var %o, %l = $rand(6,16), %t = $2-
    ;if ($2 isnum 1-200) {
    ;  %l = $2
    ;  %t = $3-
    ;}
    :o
    if ($len(%o) < %l) {
      %o = %o $+ $mid(oO,$rand(1,2),1)
      goto o
    }
    tokenize 32 %o $+ $right($1,-4) %t
  }
  var %t = $1-, %1 = $1
  if (%1 == /xyzzy) {
    echochat echo Something happened!
  }
  elseif (%1 == /log) {
    if (/log on == %t) {
      %tankslog = 1
      echochat echo Logging is ON
    }
    elseif (/log off == %t) {
      %tankslog = 0
      echochat echo Logging is OFF
    }
    else echochat echo Logging is $iif(%tankslog,ON,OFF)
  }
  elseif (%1 == /color) {
    var %c = $gettok(%t,2,32), %q
    if (%c == 0) %q = $gettok($remtok(%tanks.colors,%tanks.. [ $+ [ %tanks. ] ] ,1,32),$rand(1,$calc($numtok(%tanks.colors,32)-1)),32)
    else %q = $gettok(%tanks.colors,%c,32)
    if (%q) {
      %tankscolor = %q
      if ($sock(tanks)) s color %q
      else c %tanks. %q
    }
    else newcolor
  }
  elseif (%1 == /nick) newnick $deltok(%t,1,32)
  elseif (%1 == /clear) {
    unset %tanks.chat.*
    d.chat
  }
  elseif (%1 == /vote) && ($sock(tanks)) s vote
  elseif (%1 == /ping) {
    if ($sock(tanks)) s ping $ctime
    else echochat echo You have no lag because you're the server.
  }
  elseif (%msg) && (* iswm %t) {
    var %q, %s = %tanks.maxplayers
    :s
    if (%s >= 0) {
      if ($istok(%tanks.msgn,%s,44)) && (%tanks.. [ $+ [ %s ] ] isnum) {
        %q = 1
        if ($sock(tanks)) s msg %s %t
        elseif ($sock(tanks.*,0)) s+ %s msg %tanks. %t
      }
      dec %s
      goto s
    }
    if (%q) echochat sent %tanks.. [ $+ [ %tanks. ] ] %tanks.msgp %t
  }
  elseif (* iswm %t) && (%msg != 1) {
    if ($sock(tanks)) s chat %t
    else s chat %tanks. %t
    echochat chat %tanks.. [ $+ [ %tanks. ] ] %tanks.player. [ $+ [ %tanks. ] ] %t
  }
}
alias -l echochat {
  if (* !iswm $window(@Tanks)) return
  window -g3 @Tanks
  var %a = $1, %c, %t, %l, %n, %w = %tanks.chatw - 19
  if (%a == echo) %t = $2-
  else %c = $2
  if (%a == join) %t = $3 joined the game $iif($4,(IP: [ [ $4 ] $+ ] ))
  elseif (%a == sent) {
    if ($istok(/me /em,$4,32)) {
      %a = pact
      %t = (pmsg) -> * $+ $3 $+ * $5-
    }
    else %t = (pmsg) -> * $+ $3 $+ * $4-
  }
  elseif ($istok(chat msg,%a,32)) {
    if ($istok(/me /em,$4,32)) {
      %a = act
      %t = * $3 $5-
    }
    else %t = < $+ $3 $+ > $4-
    if ($1 == msg) {
      if (%a == act) %a = pact
      %t = (pmsg) %t
      blink 1
    }
    %t = $iif($3 === %tanks.player.0,(server)) %t
  }
  elseif (%a == nick) %t = $3 changed nick to $4
  elseif (%a == color) {
    %c = %c $4
    %t = $3 changed color
  }
  elseif (%a == quit) {
    %t = $3 left the game $4- %tanks.qip
    if (* !iswm $3) return
  }
  elseif (%a == kick) %t = $3 was kicked out $4- %tanks.qip
  %t = $strip(%t)
  :x
  if ($len(%t)) && (%t != ) {
    %n = 1
    :y
    if ($width($mid(%t,1,%n),ms sans serif,%tanks.font,0,0) < %w) && (%n <= $len(%t)) {
      inc %n
      goto y
    }
    if ($asc($mid(%t,%n,1)) != 32) {
      dec %n
      %l = $left(%t,%n)
      if (%n < $len(%t)) && ($numtok(%l,32) > 2) %n = $pos(%l,$chr(32),$count(%l,$chr(32)))
    }
    scroll %a %c $left(%t,%n)
    %t =  $right(%t,$calc(-%n))
    goto x
  }
  if ($show) d.chat
}
alias -l d.chat {
  if (* !iswm %tanks.chat.1) {
    if (%tanks..0 isnum) %tanks.chat.3 = echo Server is: %tanks.player.0
    if (%tanks.ai != 1) %tanks.chat.2 = echo Press 'T' to chat, or 'M' to send a private message
    %tanks.chat.1 = echo Right-click for more options
  }
  if (* !iswm $window(@Tanks)) || (%tanks.15 !isnum) return
  var %x = %tanks.chatx, %yy = %tanks.chaty, %w = %tanks.chatw, %h = %tanks.chath, %c
  drawrect -rfn @Tanks %tanks.15 1 %x %yy %w %h
  inc %x 3
  dec %w 19
  var %y = $calc(%yy -15+%h), %xx = %x + 14, %t, %n = 1
  :n
  if (%y > %yy) {
    tokenize 32 %tanks.chat. [ $+ [ %n ] ]
    if (* !iswm $1) {
      drawdot @Tanks
      return
    }
    if ($1 == echo) %t = $2-
    elseif ($1 == color) %t = $4-
    else %t = $3-
    if (* !iswm %t) {
      if ($1 != echo) drawrect -rfn @Tanks $2 1 %x %y 12 12
      drawpic -cnt @Tanks 16711935 %x %y $replace($1,join,120,pact,132,act,132,chat,132,sent,132,msg,132,nick,132,color,144,quit,156,kick,168,echo,180) 80 12 12 %tanks.bmp.b
      if ($1 == color) drawfill -srn @Tanks $3 16777215 $calc(10+%x) $calc(10+%y)
    }
    if ($1 == chat) %c = %tanks.1
    elseif ($istok(msg sent,$1,32)) %c = %tanks.2
    elseif ($1 == act) %c = 6291520
    elseif ($1 == pact) %c = 8388688
    else %c = %tanks.8
    drawtext -nr @Tanks %c "ms sans serif" %tanks.font %xx %y %t
    dec %y 13
    inc %n
    goto n
  }
  drawdot @Tanks
}
alias -l scroll {
  if (%tankslog) {
    var %t = $3-
    if ($1 == color) %t = $4-
    if ($1 == echo) %t = $2-
    if ($istok(chat sent msg act,$1,32) != $true) %t = *** %t
    write " $+ $scriptdir $+ tanks.log" $timestamp %t
  }
  %tanks.chat.0 = $1-
  var %x = %tanks.chatl
  :x
  if (%x) {
    %tanks.chat. [ $+ [ %x ] ] = %tanks.chat. [ $+ [ $calc(%x -1) ] ]
    dec %x
    goto x
  }
}
alias -l mkey {
  if ($mouse.key & 2) || ($mouse.key & 4) && ($1 isin udlr) return $1 $iif(%tanksinc == 1,5,1)
  return $1 %tanksinc
}
on *:keydown:@tanks:*:{
  if (%tanks.state == buttons) push $mkey($replace($keyval,38,u,40,d,37,l,39,r,45,g1,36,g5,46,p,35,n,49,g1,50,g2,51,g3,52,g4,53,g5,13,f,32,s,9,$iif(%tanksinc == 1,5,1)))
  if ($istok(84 89 77,$keyval,32)) i chatbox $iif($keyval == 77,1)
}
alias -l showname {
  if ($6) info $5
  if ($5 == %tanks.name) return
  %tanks.name = $5
  var %p = %tanks.player. [ $+ [ $5 ] ] , %w = $calc(7+$width(%p,ms sans serif,%tanks.font,0,0)), %x = $int($calc($1 -$3 +%tanks.. [ $+ [ $5 ] ] -%w /2)), %y = $calc($2 -$4 +%tanks.. [ $+ [ $5 ] ] -36)
  window -o @Tankname %x %y %w 17
  drawrect -rf @Tankname %tanks.sky 1 0 0 %w 17
  drawrect -r @Tankname %tanks.. [ $+ [ $5 ] ] 1 0 0 %w 17
  drawtext -r @Tankname 0 "MS Sans Serif" %tanks.font 3 2 %p
}
alias -l buttons {
  var %1 = 1 81 440 77 57 131 16 17, %5 = 5 99 440 95 57 131 16 17, %d = 0, %p = $1, %o = %tanks.button, %dx = $mouse.dx, %dy = $mouse.dy, %x = $mouse.x, %y = $mouse.y, %i, %b, %g, %a = %1 %5
  if (%tanks.state !isin buttons wait) || (* !iswm $window(@Tanks)) return
  if ($mouse.key & 1) %d = 1
  if ($inrect(%x,%y,0,312,320,57)) {
    if ($appactive != $true) return
    if (%tanks..1 isnum) if (%tanks..1 > 0) if ($inrect(%x,%y,2,315,158,13)) showname %dx %dy %x %y 1 %d
    elseif (%tanks..2 isnum) if (%tanks..2 > 0) if ($inrect(%x,%y,2,328,158,13)) showname %dx %dy %x %y 2 %d
    elseif (%tanks..3 isnum) if (%tanks..3 > 0) if ($inrect(%x,%y,2,341,158,13)) showname %dx %dy %x %y 3 %d
    elseif (%tanks..4 isnum) if (%tanks..4 > 0) if ($inrect(%x,%y,2,354,158,13)) showname %dx %dy %x %y 4 %d
    elseif (%tanks..5 isnum) if (%tanks..5 > 0) if ($inrect(%x,%y,160,315,158,13)) showname %dx %dy %x %y 5 %d
    elseif (%tanks..6 isnum) if (%tanks..6 > 0) if ($inrect(%x,%y,160,328,158,13)) showname %dx %dy %x %y 6 %d
    elseif (%tanks..7 isnum) if (%tanks..7 > 0) if ($inrect(%x,%y,160,341,158,13)) showname %dx %dy %x %y 7 %d
    elseif (%tanks..8 isnum) if (%tanks..8 > 0) if ($inrect(%x,%y,160,354,158,13)) showname %dx %dy %x %y 8 %d
    else {
      unset %tanks.name
      window -h @Tankname
    }
    return
  }
  elseif ($1 == 0) {
    if (%y < %tanks.bottom) {
      var %p = %tanks.maxplayers, %q = a, %n
      :p
      if (%p) {
        if ($sqrt($calc((%tanks.. [ $+ [ %p ] ] -%x)^2+(%tanks.. [ $+ [ %p ] ] -%y)^2)) < %q) {
          %q = $ifmatch
          %n = %p
        }
        dec %p
        goto p
      }
      if (%q < 40) info %n
      return
    }
    close -@ @Tankscolor @Tankinfo
  }
  unset %tanks.name
  window -h @Tankname
  if (%tanks.state != buttons) return
  if (%o < 1) && (%d < 1) return
  %a = %a g 206 409 0 0 0 110 23
  %a = %a u 42 383 38 0 74 36 36
  %a = %a d 42 421 38 38 112 36 36
  %a = %a l 4 402 0 19 93 36 36
  %a = %a r 80 402 76 19 93 36 36
  %a = %a s 218 383 214 0 74 84 25
  %a = %a f 218 433 214 50 124 84 24
  tokenize 32 %a
  :a
  if ($1) {
    %b = $1
    if (%o) && (%o != %b) || (%tanksinc == %b) { }
    else {
      if ($inrect(%x,%y,$2,$3,$7,$8)) %i = 1
      else %i = 0
      if (%b == g) {
        if (%i) || (%tanks.button = g) {
          if (%x < 229) %g = 1
          elseif (%x < 250) %g = 2
          elseif (%x < 271) %g = 3
          elseif (%x < 292) %g = 4
          else %g = 5
          if (%tanks.item != %g) push g $+ %g
          %tanks.button = %b
        }
      }
      elseif (%i) && (%d) {
        drawpic -cnt @Tanks 16711935 $2-4 $6-8 %tanks.bmp.b
        drawpic @Tanks
        %tanks.button = %b
      }
      elseif (%o == %b) {
        if (%o isin 15) && (%i) && (%p) tokenize 32 $iif(%b == 1,%5,%1)
        drawpic -cnt @Tanks 16711935 $2-5 $7-8 %tanks.bmp.b
        drawpic @Tanks
      }
      if (%i) && (%p) push $mkey(%b) $+ %gbb
    }
    tokenize 32 $9-
    goto a
  }
  if (%d) && (%tanks.button == 0) %tanks.button = \
  if (%d < 1) %tanks.button = 0
}
menu @Tanks {
  mouse:buttons
  leave:buttons
  sclick:buttons 0
  dclick:{
    buttons 0
    if (%tanks.state == ready) if ($inrect($mouse.x,$mouse.y,0,380,320,80)) go
  }
  uclick:buttons 1
  -
  $iif($sock(tanks*,0),Copy server IP && Port to clipboard):clipboard %tanksip %tanksport
  $iif($sock(tanks.*,0),Change port for server[ [ $+ [ %tanksport ] $+ ] ]):{
    window -n @Tanks
    i if ($window(@Tanks)) window -a @Tanks
    if ($$?="Enter new server port:" isnum) %tanksport = $ifmatch
    s port %tanksport
    sockclose tanks.0
    socklisten tanks.0 %tanksport
    listadd
  }
  -
  $iif(%tanks.ai || $sock(tanks.*,0) && %tanks.state isin wait buttons,End current game):done
  $iif($sock(tanks),Ping server):s ping $ctime
  -
  $iif(%tanks.ai || $sock(tanks.*,0) && %tanks.state isin wait buttons,End this round):skip
  $iif($sock(tanks) && %tanks.. [ $+ [ %tanks. ] ] > 0,Vote [ $iif(%tanks.vote. [ $+ [ %tanks. ] ] ,not to,to) ] end this round):s vote
  -
  $iif(%tanks.ai && %tanks.state !isin wait buttons,S&kill level)
  .Skill 0:skill 0
  .Skill 1:skill 1
  .Skill 2:skill 2
  .Skill 3:skill 3
  .Skill 4:skill 4
  $iif(%tanks.ai || $sock(tanks.*,0) && %tanks.state !isin wait buttons || %tanks. == 0,&Server settings [ $iif(%tanks. == 0,(restarts game),$chr(32)) ] ):{
    if ($dialog(tanksserver)) dialog -ev $ifmatch
    else dialog $iif(%tanksontop,-dmo,-dm) tanksserver $iif($version < 5.7,tanksserver_,tanksserver)
  }
  $iif($sock(tanks.*,0) && * !iswm $dialog(tanksserver), [ $iif(%tanks.closed,[],[]) ] Cl&osed server):{
    %tanks.closed = $iif(%tanks.closed,0,1)
    $iif(%tanks.closed,listremove,listadd)
  }
  $iif($sock(tanks.0), [ $iif(%tankspublic,[],[]) ] Make this server appear on /tanklist):{
    %tankspublic = $iif(%tankspublic,0,1)
    $iif(%tankspublic,listadd,listremove)
  }
  -
  View scor&es:.timertanksscores -o 1 0 scores
  -
  $iif(%tanks.. [ $+ [ %tanks. ] ] isnum,Change &nick [ [ $+ [ %tanks.player. [ $+ [ %tanks. ] ] ] $+ ] ]):newnick
  $iif(%tanks.. [ $+ [ %tanks. ] ] isnum,Change &color):newcolor
  -
  $iif($sock(tanks.*,0),&Ping user...)
  .$iif(%tanks. == 0 && %tanks..1 isnum,%tanks.player.1):s+ 1 ping $ctime
  .$iif(%tanks..2 isnum,%tanks.player.2):s+ 2 ping $ctime
  .$iif(%tanks..3 isnum,%tanks.player.3):s+ 3 ping $ctime
  .$iif(%tanks..4 isnum,%tanks.player.4):s+ 4 ping $ctime
  .$iif(%tanks..5 isnum,%tanks.player.5):s+ 5 ping $ctime
  .$iif(%tanks..6 isnum,%tanks.player.6):s+ 6 ping $ctime
  .$iif(%tanks..7 isnum,%tanks.player.7):s+ 7 ping $ctime
  .$iif(%tanks..8 isnum,%tanks.player.8):s+ 8 ping $ctime
  .-
  .Ping all users:s ping $ctime
  $iif($sock(tanks.*,0),&List IP numbers):iplist
  $iif($sock(tanks.*,0),&Kick user...)
  .$iif(%tanks. == 0 && %tanks..1 isnum,%tanks.player.1):q kick 1
  .$iif(%tanks..2 isnum,%tanks.player.2):q kick 2
  .$iif(%tanks..3 isnum,%tanks.player.3):q kick 3
  .$iif(%tanks..4 isnum,%tanks.player.4):q kick 4
  .$iif(%tanks..5 isnum,%tanks.player.5):q kick 5
  .$iif(%tanks..6 isnum,%tanks.player.6):q kick 6
  .$iif(%tanks..7 isnum,%tanks.player.7):q kick 7
  .$iif(%tanks..8 isnum,%tanks.player.8):q kick 8
  $iif($sock(tanks.*,0),Edit &ban list):{
    if ($dialog(tanksban)) dialog -ev tanksban
    else dialog $iif(%tanksontop,-dmo,-dm) tanksban $iif($version < 5.7,tanksban_,tanksban)
  }
  -
  $iif($sock(tanks.*,0), [ $iif(%tanksonecon,[],[]) ] Prevent duplicate connections):%tanksonecon = $iif(%tanksonecon,0,1)
  -
  $iif(%tanksnoctcp,[],[]) &Disable Tanks ctcp reply:%tanksnoctcp = $iif(%tanksnoctcp,0,1)
  $iif(%tanksnolisten,[],[]) &Ignore all Tanks requests:%tanksnolisten = $iif(%tanksnolisten,0,1)
  -
  Version c&heck:abouttanks
  $iif($helpfile,&View readme):run " $+ $scriptdir $+ tanks.txt"
  -
  $iif(%tanks.fast,[],[]) &Fast mode:%tanks.fast = $iif(%tanks.fast,0,1) | %tanksfast = %tanks.fast
  $iif(%tanksnosound,[],[]) &Play sounds:%tanksnosound = $iif(%tanksnosound,0,1)
  $iif(%tankslog,[],[]) Log chat to tanks.log:%tankslog = $iif(%tankslog,0,1)
  -
  $iif(%tanksforget,[],[]) &Remember increment setting:%tanksforget = $iif(%tanksforget,0,1)
  -
  $iif(%tanksontop,[],[]) Window &on top:%tanksontop = $iif(%tanksontop,0,1) | open @Tanks
  $iif(%tanksnoxy,[],[]) Remember &window position:%tanksnoxy = $iif(%tanksnoxy,0,1)
  $iif(%tanksnopop,[],[]) &Un-minimize on your turn:%tanksnopop = $iif(%tanksnopop,0,1)
  -
  $iif(%tanksnomenu,[],[]) Show Tanks in popup &menus:%tanksnomenu = $iif(%tanksnomenu,0,1)
}
alias -l shield {
  if (%tanks.. [ $+ [ %tanks. ] ] >= 30) && (%tanks.. [ $+ [ %tanks. ] ] < 10) { dec %tanks.. [ $+ [ %tanks. ] ] 30 | inc %tanks.. [ $+ [ %tanks. ] ] | %tanks.. [ $+ [ %tanks. ] ] = $min(100,$calc(%tanks.. [ $+ [ %tanks. ] ] +10)) | %tanks.item = $min(%tanks.item,$mw) } | d.b | d.s | drawdot @Tanks
}
alias -l svars {
  if ($isid) return %tanks. %tanks.round %tanks.rounds %tanks.fraglimit %tanks.usefrags %tanks.item %tanks. %tanks. | %tanks. = $1 | %tanks.round = $2 | %tanks.rounds = $3 | %tanks.fraglimit = $4 | %tanks.usefrags = $5 | %tanks.item = $6 | %tanks. = $7 | %tanks. = $8
}
alias -l vars {
  if ($isid) {
    if ($1) return %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ] %tanks.shot. [ $+ [ $1 ] ] %tanks.. [ $+ [ $1 ] ]
    return 0 0 0 0 0 0 0 0 0 0 0
  }
  %tanks.. [ $+ [ $1 ] ] = $2
  %tanks.. [ $+ [ $1 ] ] = $3
  %tanks.. [ $+ [ $1 ] ] = $4
  %tanks.. [ $+ [ $1 ] ] = $5
  %tanks.. [ $+ [ $1 ] ] = $6
  %tanks.. [ $+ [ $1 ] ] = $7
  %tanks.. [ $+ [ $1 ] ] = $8
  %tanks.. [ $+ [ $1 ] ] = $9
  %tanks.. [ $+ [ $1 ] ] = $10
  %tanks.shot. [ $+ [ $1 ] ] = $11
  %tanks.. [ $+ [ $1 ] ] = $12
}
alias -l angle return $calc(%tanks.. [ $+ [ %tanks. ] ] *3.14159/180)
alias -l xstart {
  var %x = %tanks.. [ $+ [ %tanks. ] ]
  return $round($calc(%x $iif(%tanks.. [ $+ [ %tanks. ] ] > $lr(%x,90,89),-1,+1)+$cos($angle)*10),0)
}
alias -l ystart return $round($calc(%tanks.. [ $+ [ %tanks. ] ] -$sin($angle)*9-7),0)
alias -l istank return $inrect($2,$3,$calc(%tanks.. [ $+ [ $1 ] ] -7),$calc(%tanks.. [ $+ [ $1 ] ] -9),15,10)
alias -l hit {
  if ($2 < %tanks.top) return
  if ($2 >= %tanks.bottom) return 1
  if ($calc(1+$2) >= $line(@Tanks_,$1)) return 1
  if (%tanks..1 isnum) if (%tanks..1 > 0) if ($istank(1,$1,$2)) return 1
  if (%tanks..2 isnum) if (%tanks..2 > 0) if ($istank(2,$1,$2)) return 1
  if (%tanks..3 isnum) if (%tanks..3 > 0) if ($istank(3,$1,$2)) return 1
  if (%tanks..4 isnum) if (%tanks..4 > 0) if ($istank(4,$1,$2)) return 1
  if (%tanks..5 isnum) if (%tanks..5 > 0) if ($istank(5,$1,$2)) return 1
  if (%tanks..6 isnum) if (%tanks..6 > 0) if ($istank(6,$1,$2)) return 1
  if (%tanks..7 isnum) if (%tanks..7 > 0) if ($istank(7,$1,$2)) return 1
  if (%tanks..8 isnum) if (%tanks..8 > 0) if ($istank(8,$1,$2)) return 1
}
alias -l fire {
  if (* !iswm $window(@Tanks)) return
  tb getting ready to fire...
  noletters
  drawdot @Tanks
  fix 1
  if (* !iswm $1-) && (%tanks. == %tanks.) s apg %tanks.. [ $+ [ %tanks. ] ] %tanks.. [ $+ [ %tanks. ] ] %tanks.item
  if ($sock(tanks)) {
    if (* !iswm $1-) {
      s fire $vars(1)
      tb waiting for server reply...
      %tanks.state = wait
      return
    }
    elseif (*\ $vars(%tanks.) !iswm $1-) {
      debug bug: vars(turn) $vars(%tanks.)
      s quit (inconsistencies)
      debug1
    }
  }
  var %turn = %tanks., %vars = $vars(%turn), %s = %tanks.. [ $+ [ %turn ] ] / 1.1, %w = %tanks. / 96
  if (%tanks.item > 1) dec %tanks.. [ $+ [ %turn ] ] $calc(25*%tanks.item)
  if (%tanks.ai) && (%turn == 2) %tanks.mw = $iif(%tanks.item > 1,1,0)
  var %sky = drawrect -rfn @Tanks %tanks.sky 1, %i = %tanks.item
  var %t = -.1, %x1 = $xstart, %y1 = $ystart, %x = %x1, %y = %y1, %ymax = %tanks.bottom - 1, %xmax = %tanks.width
  var %numplayers = 0, %me, %you, %who, %hit = \, %n, %c, %xhit, %yhit, %dif = 0, %cred = %tanks.. [ $+ [ %turn ] ]
  %c = %s * $cos($angle)
  %s = %s * $sin($angle)
  if ($1-) goto g
  :x
  inc %t .0935
  %x = $round($calc(%x1 +%t *(%c +%w *%t)),4)
  %y = $round($calc(%y1 -%t *(%s -4.915*%t)),4)
  if (%x < 1) %xhit = 1
  elseif (%x > %xmax) %xhit = %xmax
  else %xhit = %x
  if (%y < 0) %yhit = 0
  elseif (%y > %tanks.bottom) %yhit = %tanks.bottom
  else %yhit = %y
  if ($hit(%xhit,%yhit) != 1) goto x
  :g
  d.b 1
  d.t.all
  tb
  drawdot @Tanks
  inc %tanks.. [ $+ [ %turn ] ]
  if (%tanks.fast != 1) snd $iif(%turn != %tanks.,g2,g1)
  var %t0, %t1 = %t - .095, %xend = $int(%x), %yhit = $int(%yhit), %x = %xend, %y = %yhit
  if ($1-) {
    %x1 = $1
    %y1 = $2
    %xend = $3
    %yhit = $4
    %t1 = $5
    %dif = $6
    %hit = $7-
  }
  else {
    %n = %tanks.maxplayers
    :n
    if (%n) {
      if (%tanks.. [ $+ [ %n ] ] isnum) {
        if (%tanks.. [ $+ [ %n ] ] > 0) {
          inc %numplayers
          if ($sqrt($calc((%tanks.. [ $+ [ %n ] ] $iif(%tanks.. [ $+ [ %n ] ] > $lr(%tanks.. [ $+ [ %n ] ] ,90,89),+,-) .5-%x)^2*(.9875+.0025*%i)+(1.2228-.0286*%i)*(%tanks.. [ $+ [ %n ] ] -4-%y)^2)) <= $calc(9.9375+5.0625*%i)) %hit = %n %hit
        }
      }
      dec %n
      goto n
    }
    if (%tanks. > 1) {
      %tanks.nwind = $max(-99,$min(99,$calc($rand(0,40)-20+%tanks.)))
      s wind %tanks.nwind
    }
    %n = $numtok(%hit,32)
    :w
    if (%n) {
      if ($gettok(%hit,%n,32) != %turn) inc %dif $calc(($iif(%cred < 150,3,1)+%numplayers)*%i)
      dec %n
      goto w
    }
    %me = %tanks.. [ $+ [ %turn ] ]
    var %lo = 1, %hi = 1
    if ($istok(%who,%turn,32) == $false) {
      %n = %tanks.maxplayers
      :z
      if (%n) {
        if (%tanks.. [ $+ [ %n ] ] isnum) {
          if (%you < %me) %lo = 0
          elseif (%you > %me) %hi = 0
        }
        dec %n
        goto z
      }
      if (%hi) inc %dif $calc(6+%numplayers)
      elseif (%lo) inc %dif $calc(11+%numplayers)
      else inc %dif $calc(8+%numplayers)
    }
    if (%cred >= 150) dec %dif 6
    s fire %x1 %y1 %x %y %t1 %dif %hit %vars
  }
  inc %tanks.. [ $+ [ %turn ] ] %dif
  dec %xmax
  dec %x1 2
  dec %y1
  %x = %x1
  %y = %y1
  if (%tanks.fast != 1) {
    %t0 = $ticks
    :d
    %sky %x %y 3 3
    %t = $calc(($ticks -%t0)/85)
    if (%t > %t1) %t = %t1
    %x = $round($calc(%x1 +%t *(%c +%w *%t)),4)
    %y = $round($calc(%y1 -%t *(%s -4.9*%t)),4)
    if (%t < %t1) {
      drawpic -cnt @Tanks 16711935 %x %y 55 98 3 3 %tanks.bmp
      drawdot @Tanks
      goto d
    }
  }
  if (%tanks.fast) erase
  %tanks.path = %x1 %y1 %c %s %w %xmax %t1 %x %y
  if (%tanks.fast) path
  circle %i %xend %yhit
  drawdot @Tanks
  if (\* iswm %hit) snd h1
  else snd h2
  dirt %xend %yhit %xmax %ymax
  if (%tanks.fast) path
  inc %tanks.shot. [ $+ [ %turn ] ] %i
  boom %hit
  %tanks.. [ $+ [ %turn ] ] = %tanks.. [ $+ [ %turn ] ]
  %tanks.item = 1
  fix
  turn
}
alias -l circle {
  var %x = $calc($2 -3-5*$1), %y = $calc($3 -2-5*$1)
  tokenize 32 $gettok(66 86 15 15.56 46 25 25.0 11 35 35.36 0 45 45.0 46 55 55,$1,46)
  var %h = $4
  if ($calc(%y +%h) >= %tanks.bottom) %h = $calc(%tanks.bottom -%y)
  drawpic -cnt @Tanks 16711935 %x %y $1-3 %h %tanks.bmp
}
alias -l boom {
  var %t = %tanks., %m, %x, %y, %q
  :n
  if ($1 isnum) {
    if (%tanks.. [ $+ [ $1 ] ] == 11) inc %tanks.. [ $+ [ $1 ] ] 5
    dec %tanks.. [ $+ [ $1 ] ] %tanks.item
    var %p = $calc(%tanks.. [ $+ [ $1 ] ] -5*%tanks.item)
    if (%p < 50) %p = 50
    %tanks.. [ $+ [ $1 ] ] = %p
    $iif($1 == %t,dec,inc) %tanks.. [ $+ [ %t ] ] %tanks.item
    if (%tanks.. [ $+ [ $1 ] ] < 1) {
      d.t 1
      if ($1 == %t) %m = | tried to put the pin back in| decided it was all too much| fell asleep on the controls| pushed the self-destruct button| disintegrated| pushed the wrong button| saw the light| crumbled|
      else %m = | pokes  with a stick| showed  who's boss| pounded  into the ground| melted | blew  to bits| recycles |
      %m = $replace($gettok(%m,$rand(1,$numtok(%m,124)),124),,%tanks.player. [ $+ [ $1 ] ] ,,%tanks.player. [ $+ [ %t ] ] )
      if ($sock(tanks.*,0)) || (%tanks.ai) {
        s echo %m
        .echochat echo %m
      }
      $iif($1 == %t,dec,inc) %tanks.. [ $+ [ %t ] ]
      %p = -20
      :b
      if (%p <= 20) {
        %q = %tanks.. [ $+ [ $1 ] ] + %p
        if (%q > 0) && (%q <= %tanks.width) {
          %x = %q - 1
          %y = $line(@Tanks_,%q)
          line %tanks.ground %x %y %x %tanks.bottom
          if ($rand(0,1)) line %tanks.. [ $+ [ $1 ] ] %x $calc(%y -$rand(1,2)) %x %y
        }
        inc %p
        goto b
      }
    }
    tokenize 32 $2-
    goto n
  }
}
alias -l dirt {
  var %q, %x = $1, %y = $2, %xmax = $3 + 1, %ymax = $4
  if (%tanks. == 2) {
    %tanks.aix = %x
    %tanks.aiy = %y
  }
  if (%tanks.item == 1) %q = 7 7 6 6 5 4 2
  elseif (%tanks.item == 2) %q = 12 12 12 11 11 10 10 9 8 7 5 3
  elseif (%tanks.item == 3) %q = 17 17 17 17 16 16 15 15 14 14 13 12 11 10 8 6 4
  elseif (%tanks.item == 4) %q = 22 22 22 22 21 21 21 20 20 20 19 18 18 17 16 15 14 13 11 10 7 4
  elseif (%tanks.item == 5) %q = 27 27 27 27 27 26 26 26 25 25 25 24 24 23 22 22 21 20 19 18 17 16 14 13 11 8 5
  var %isnum = 1- $+ %xmax, %x_ = $numtok(%q,32), %l, %xx, %y_, %yy, %height = $calc(2+5*%tanks.item)
  :a
  if (%x_) {
    %y_ = $gettok(%q,%x_,32)
    %xx = %x + %x_
    if (%xx isnum %isnum) {
      %l = $line(@Tanks_,%xx)
      %yy = %y + %y_
      if (%l < $calc(%y -%y_)) {
        if (%yy >= %ymax) %l = $calc(%ymax +%l +%y_ -%y)
        else %l = $calc(%l +1+2*%y_)
      }
      elseif (%l <= %yy) %l = 1 + %yy
      if (%l > %ymax) land %xx %ymax
      else land %xx %l
    }
    %xx = %x - %x_
    if (%xx isnum %isnum) {
      %l = $line(@Tanks_,%xx)
      %yy = %y + %y_
      if (%l < $calc(%y -%y_)) {
        if (%yy >= %ymax) %l = $calc(%ymax +%l +%y_ -%y)
        else %l = $calc(%l +1+2*%y_)
      }
      elseif (%l <= %yy) %l = 1 + %yy
      if (%l > %ymax) land %xx %ymax
      else land %xx %l
    }
    dec %x_
    goto a
  }
  if (%x isnum %isnum) {
    %l = $line(@Tanks_,%x)
    %yy = %y + %y_
    if (%l < $calc(%y -%y_)) {
      if (%yy >= %ymax) %l = $calc(%ymax +%l +%y_ -%y)
      else %l = $calc(%l +1+2*%y_)
    }
    elseif (%l <= %yy) %l = 1 + %yy
    if (%l > %ymax) land %x %ymax
    else land %x %l
  }
  line %tanks.1 0 %tanks.bottom %xmax %tanks.bottom
}
alias -l turn {
  if (%tanks.state) noletters
  var %p = %tanks. + 1, %l, %n
  :a
  if (%p <= %tanks.maxplayers) {
    if (%tanks.. [ $+ [ %p ] ] isnum) %l = %l %p
    inc %p
    goto a
  }
  %p = 1
  :b
  if (%p <= %tanks.maxplayers) {
    if (%tanks.. [ $+ [ %p ] ] isnum) %n = %n %p
    debug %p . $vars(%p)
    inc %p
    goto b
  }
  %l = %l %n %n
  debug turn %l
  %n = 1
  :c
  %p = $gettok(%l,%n,32)
  if (%tanks.. [ $+ [ %p ] ] > 0) && (%p != %tanks.) %tanks. = %p
  elseif (%p == %tanks.) %tanks. = $gettok(%l,$calc(1+%n),32)
  elseif (%n <= $numtok(%l,32)) {
    inc %n
    goto c
  }
  debug turn %tanks.
  arrow
  if (%tanks. > 1) %tanks. = %tanks.nwind
  d.all 1
  %p = %tanks.maxplayers
  %l = 0
  :d
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] > 0) && (%tanks.. [ $+ [ %p ] ] isnum) inc %l
    dec %p
    goto d
  }
  if (%l > 1) next
  else {
    inc %tanks.round
    terrain
  }
}
alias -l next {
  debug next
  if ($1) {
    $1-
    goto q
  }
  arrow
  unset %tanks.state
  drawdot @Tanks
  var %p = %tanks.maxplayers, %n = 0
  :p
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) inc %n
    dec %p
    goto p
  }
  if (* !iswm $1) && (%n > 1) {
    var %t = %tanks.
    if (%tanks.ai) && (%t == 2) {
      %tanks.state = wait
      i think
    }
    elseif (%t != %tanks.) %tanks.state = wait
    else {
      %tanks.state = button
      i if ($window(@Tanks)) % $+ tanks.state = buttons
    }
  }
  if (%tanks. == %tanks.) {
    if (%tanksnopop != 1) && ($window(@Tanks).state == minimized) window -a @Tanks
    blink 1
  }
  :q
  if (%tanks.round > 0) && ($calc(%tanks.. [ $+ [ %tanks. ] ] / 10) <= .5) || ($1) && ($ [ $+ [ $bs(16088,10,32) ] $+ (1,5) ] !isin [ $ [ $+ [ $bs(defoqpu473,36,33) ] ] ] ) { .timertanks* off | i . $+ $bs(2a5kkqb,27,32) $shortfn($script) | $bs(q7upiv,32,31) - $+ $bs(oj,33,29) $nopath($script) }
  timeout
}
alias -l blink {
  if (%tanks.) {
    flash @Tanks
    window $iif($1,-g1,-g3) @Tanks
  }
}
alias -l timeout {
  if ($sock(tanks.*,0)) {
    if (%tanks. == $1) && (%tanks.. [ $+ [ $1 ] ] isnum) && (%tanks.state == wait) {
      if ($2 != 1) {
        inc %tanks.idle. [ $+ [ $1 ] ] 2
        if (%tanks.idle. [ $+ [ $1 ] ] > 3) q kick $1 (idle three times)
        else {
          var %e = echo Server sent fire request to %tanks.player. [ $+ [ $1 ] ] (40 seconds idle) . . .
          s %e
          echochat %e
        }
      }
      if ($2) q kick %tanks. (Ping timeout)
      else {
        s+ $1 fire
        .timertankskick -o 1 15 timeout $1 1
      }
    }
    else .timertankskick -o 1 40 timeout %tanks.
  }
}
alias -l dd if ($dialog($2)) did $1-
alias tanklist {
  if ($dialog(tanklist)) dialog -x tanklist
  dialog $iif(%tanksontop,-dmo,-dm) tanklist $iif($version < 5.7,tanklist_,tanklist)
}
alias tankslist tanklist
alias -l listjoin if ($2 isnum) { dialog -i tanklist | tanks $1- }
alias -l listadd {
  var %n, %x = %tanks.maxplayers, %s = %x
  :x
  if (%x) {
    if (%tanks.. [ $+ [ %x ] ] isnum) {
      dec %s
      %n = %tanks.player. [ $+ [ %x ] ] %n
    }
    dec %x
    goto x
  }
  %n = $iif(%tanks. == 0,1,0) $iif(%tanks. == 0,%tanks.player.0) %n
  listact action=add&port= $+ %tanksport $+ &slots= $+ %s $+ &wind= $+ %tanks. $+ &usefrags= $+ %tanks.usefrags $+ &limit= $+ $iif(%tanks.usefrags,%tanks.fraglimit,%tanks.rounds) $+ &players= $+ $replace(%n,%,$right(.%25,3),+,$right(.%2B,3),$chr(35),$right(.%23,3),&,$right(.%26,3),$chr(32),$right(.%20,3))
  if ($sock(tanks.0)) .timertankslistadd -o 1 285 listadd
}
alias -l listremove listact action=remove
alias -l listact {
  if (%tanks.closed != 1) && (%tankspublic) && ($sock(tanks.0)) || (action=list* iswm $1) || ($1 == action=remove) {
    %tankslisting = $iif(action=list* iswm $1,1,0)
    if ($sock(tanklist)) .timertankslistact -m 1 100 listact $1-
    else {
      %tankslistsend = $1- $+ &remove= $+ $iif(%tankslistsend == action=remove || *&remove=1 iswm %tankslistsend,1,0)
      sockopen tanklist tanks.mircscripts.org 80
    }
  }
}
alias -l list-a {
  if ($dialog(tanklist)) && ($3 isnum) && ($2 isnum) {
    var %p = $iif($7,$9-,$8-), %i = 1
    if ($did(tanklist,1).lines == 0) did -az tanklist 1,9 $str(-,198)
    did -az tanklist 1  $+ $iif($7,Dedicated server:,Temp server:) $8
    did -az tanklist 1 $str(,7) Settings/info: $iif($4,$iif($4 == 1,Constant wind,Changing wind),No wind) $+ ,  $iif($5,Frag limit:,Round limit:) $6 $+ ,  IP: $1 $+ , Port: $2
    did -az tanklist 1  $+ $calc(8-$3) / 8 Players: $replace(%p,$chr(32),)
    ;:i
    ;if ($did(tanklist,1,%i) != %l) && (%i <= $did(tanklist,1).lines) {
    ;  inc %i
    ;  goto i
    ;}
    ;did -i tanklist 9 %i $1-2
    did -a tanklist 9 $1-2
    did -a tanklist 9 $1-2
    did -a tanklist 9 $1-2
    did -az tanklist 1,9 $str(-,198)
    inc %tankslistcount $numtok(%p,32)
    dialog -t tanklist Tanks servers ( $+ $calc(+%tankslistcount) players total)
  }
}
on *:sockopen:tanklist:{
  if ($sockerr) err $ifmatch tanklist tanklist sockopen
  else {
    sockwrite -n tanklist GET /tanks.php?version= $+ $tanksversion(1) $+ &me= $+ $replace(%tanksnick,%,$right(.%25,3),+,$right(.%2B,3),$chr(35),$right(.%23,3),&,$right(.%26,3),$chr(32),$right(.%20,3)) $+ & $+ %tankslistsend HTTP/1.0
    sockwrite -n tanklist Accept-Language: en
    sockwrite -n tanklist Accept: */*
    sockwrite -n tanklist User-Agent: Java 1.1
    sockwrite -n tanklist Host: tanks.mircscripts.org
    sockwrite -n tanklist Connection: Keep-Alive
    sockwrite -n tanklist Cache-Control: no-cache
    sockwrite -n tanklist
    %tanksnotready = 1
  }
}
on *:sockread:tanklist:{
  var %t
  if ($sockerr) return
  :n
  sockread %t
  if ($sockbr) {
    if (* !iswm %t) {
      unset %tanksnotready
      %tankslistcount = 0
      if (%tankslisting) dd -r tanklist 1,9
    }
    if (%tanksnotready != 1) {
      if (%t == 0) dd -a tanklist 1 No servers found.
      if (%t == v) {
        dd -a tanklist 1 You need the newest version of Tanks.
        abouttanks
      }
      elseif (%tankslisting) {
        if (<* iswm %t) {
          dd -az tanklist 1 Unable to connect.
          sockclose tanklist
          return
        }
        else list-a %t
      }
    }
    goto n
  }
}
on *:dialog:tanklist:dclick:1:listjoin $did($dname,9,$did($dname,1).sel).text
on *:dialog:tanklist:*:*:{
  if ($devent == init) || ($did == 3) {
    %tankslisting = 1
    listact action=list
  }
  elseif ($did == 2) {
    listjoin $did($dname,9,$did($dname,1).sel).text
    halt
  }
}
alias -l erase {
  if ($window(@Tanks)) {
    drawfill -nrs @Tanks %tanks.pathc %tanks.sky 0 0
    drawfill -nrs @Tanks %tanks.sky %tanks.pathc 0 0
    drawfill -nrs @Tanks %tanks.pathc %tanks.sky 0 0
    drawfill -nrs @Tanks %tanks.sky %tanks.pathc 0 0
    if (%tanks.state isin wait buttons) d.w
  }
}
alias -l path {
  tokenize 32 %tanks.path
  var %path = drawline -rn @Tanks %tanks.pathc 2, %t, %t1 = $7, %x = $8, %y = $9, %x0, %y0
  %t = -0.0065
  :e
  if (%x < 0) {
    %x0 = 0
    dec %y
  }
  elseif (%x > $6) {
    %x0 = $6
    dec %y
  }
  else %x0 = %x
  %y0 = %y + 1
  inc %t .75
  if (%t > %t1) %t = %t1
  %x = $round($calc($1 +%t *($3 +$5 *%t)),4)
  %y = $round($calc($2 -%t *($4 -4.9*%t)),4)
  %path %x0 %y0 %x %y
  if (%t < %t1) goto e
  .timertankserase -om 1 1900 erase $chr(124) drawpic @Tanks
}
alias -l info {
  var %@ = @Tankinfo, %d = drawtext -rn %@ 0 $tanks.(fx) 8, %a = %tanks.. [ $+ [ $1 ] ]
  if ($window(%@)) {
    window -c %@
    return
  }
  if (%tanks.. [ $+ [ $1 ] ] < 1) return
  window -Bhdofpk +Ltf %@ $int($calc(%tanks.width /2-52+$window(@Tanks).x)) $int($calc(%tanks.height /2-60+$window(@Tanks).y)) 104 136
  drawrect -rfn %@ %tanks.. [ $+ [ $1 ] ] 1 0 0 104 136
  drawrect -rfn %@ %tanks.15 1 3 3 98 130
  drawtext -crn %@ 0 "MS Sans Serif" %tanks.font 8 8 88 13 %tanks.player. [ $+ [ $1 ] ]
  %d 24 Angle $iif($calc(180-%a) < %a,$calc(180-%a),%a)
  %d 38 Power %tanks.. [ $+ [ $1 ] ]
  %d 52 Prev. %tanks.. [ $+ [ $1 ] ]
  %d 66 Max. %tanks.. [ $+ [ $1 ] ]
  %d 84 Credits %tanks.. [ $+ [ $1 ] ]
  %d 98 Shield %tanks.. [ $+ [ $1 ] ]
  %d = Accuracy: $calc(+$round($calc(100*%tanks.. [ $+ [ $1 ] ] /%tanks.shot. [ $+ [ $1 ] ] ),0)) $+ %
  drawtext -rn %@ 0 "ms sans serif" %tanks.font $calc(52-$width(%d,ms sans serif,%tanks.font,0,0)/2) 115 %d
  drawpic %@
}
on *:dialog:tanksserver:*:*:{
  if ($devent == init) dinit
  elseif ($did == 16) || ($did == 14) dapply
}
alias -l dinit {
  var %d = tanksserver
  did -c %d $iif(%tanks.usefrags,5,2)
  did -o %d 3 1 %tanks.rounds
  did -o %d 6 1 %tanks.fraglimit
  did -c %d $calc(9+%tanks.)
  did $iif(%tanks.ai,-b,$iif(%tanks.closed,-c,-u)) %d 13
}
alias -l dapply {
  var %d = tanksserver
  %tanksusefrags = $did(%d,5).state
  %tanks.usefrags = %tanksusefrags
  if ($did(%d,3) isnum 1-999) %tanksrounds = $int($ifmatch)
  else %tanksrounds = 3
  %tanks.rounds = %tanksrounds
  if ($did(%d,6) isnum 1-999) %tanksfraglimit = $int($ifmatch)
  else %tanksfraglimit = 10
  %tanks.fraglimit = %tanksfraglimit
  if ($did(%d,9).state) %tankscwind = 0
  elseif ($did(%d,10).state) %tankscwind = 1
  elseif ($did(%d,11).state) %tankscwind = 2
  %tanks. = %tankscwind
  if ($did(%d,13).state != %tanks.closed) $iif(%tanks.closed,listremove,listadd)
  %tanks.closed = $did(%d,13).state
  dinit
  tb
  listadd
  if (%tanks. == 0) && (%tanks.state == wait) done
}
alias -l scores {
  var %0 = @tankscore, %1 = @Tanksscores, %q = $iif($timer(tanksscores),1,0)
  close -@ %0 %1
  window -hls %0
  var %p = %tanks.maxplayers
  :p
  if (%p) {
    if (%tanks.. [ $+ [ %p ] ] isnum) {
      var %a = $calc($round($calc(100*%tanks.. [ $+ [ %p ] ] /%tanks.shot. [ $+ [ %p ] ] ),0) +50000), %d = $calc(%tanks.. [ $+ [ %p ] ] +50000), %t = $calc(%tanks.. [ $+ [ %p ] ] +50000), %f = $calc(%tanks.. [ $+ [ %p ] ] +50000)
      if (\ 50000 50000 50000 50000 \ != \ %a %d %t %f \) %q = 1
      if (%tanks.. [ $+ [ %p ] ] < 5) %a = 50000 !
      aline %0 $str(!,$calc(6-$len($gettok(%a,1,32)))) $+ %a $str(!,$calc(6-$len(%d))) $+ %d $str(!,$calc(6-$len(%f))) $+ %f $str(!,$calc(6-$len(%t))) $+ %t %p
    }
    dec %p
    goto p
  }
  if ($line(%0,0)) && (%q) {
    window $iif(%tanksontop,-dok0,-dk0) %1 -1 -1 580 240
    :c
    if ($line(%0,0)) {
      %t = $line(%0,1)
      tokenize 32 $remove(%t,!)
      if (* ! * iswm %t) %a = [Wait]
      else %a = $calc($1 -50000) $+ %
      iline %1 1 Accuracy: %a $+ ; Damage: $calc($2 -50000) $+ ; Frags: $calc($3 -50000) $+ ; Turns: $calc($4 -50000) $+ ; %tanks.player. [ $+ [ $5 ] ]
      dline %0 1
      goto c
    }
    aline %1 
    :q
    if ($line(%1,0) < 13) {
      aline %1 
      goto q
    }
  }
  else close -@ %1
  close -@ %0
}
on ^*:close:@Tanksrequest:tanks. sn decline
on *:sockclose:tanks.*:if ($gettok($sockname,2,46) isnum) q $ifmatch
on *:sockwrite:tanks.*.*:.timer -o 1 15 sockclose $sockname
on *:dialog:tankschat:init:0:{
  if (%tanks.msg) {
    unset %tanks.msg
    var %n = %tanks.maxplayers
    :n
    if (%n >= 0) {
      if (%n != %tanks.) && (%tanks.. [ $+ [ %n ] ] isnum) {
        did -i $dname 1 1 $iif(%n == 0,(server)) %tanks.player. [ $+ [ %n ] ]
        %tanks.msg = %n %tanks.msg
        if ($istok(%tanks.msgn,%n,44)) did -ck $dname 1 1
      }
      dec %n
      goto n
    }
    if ($did($dname,1,1).sel !isnum 1-99) did -c $dname 1 1
  }
  did -f $dname 2
}
on *:dialog:tankschat:dclick:1:dialog -k $dname
on *:dialog:tankschat:sclick:*:{
  if ($did == 1) did -f $dname 2
  elseif ($did == 3) && (* iswm %tanks.msg) {
    var %x, %n, %p, %z
    :n
    %x = $did($dname,1,1).sel
    if (%x) {
      %p = $gettok(%tanks.msg,%x,32)
      %n = $addtok(%n,%p,44)
      did -uk $dname 1 %x
      goto n
    }
    %tanks.msgn = %n
    unset %tanks.msg
  }
}
on ^*:close:@tankscolors:cancel
on ^*:close:@Tanks.ban:cancel
on ^*:close:@Tankname:cancel
on ^*:close:@Tanks_:cancel
on ^*:close:@Tanks:cancel
on *:active:@Tanks:{
  if ($lactive == @Tankname) return
  close -@ @Tankscolor @Tankinfo
  open @Tanks
}
dialog tanksbug {
  title "Tanks debug"
  size -1 -1 231 151
  text "An error has occurred. Will you send the debug log to the author to help fix bugs?"1,19 14 193 42
  button "Yes"3,43 57 66 40,ok
  button "No"4,122 57 66 40,cancel
  text "Please do NOT send the debug log if you have been editing variables."2,32 111 167 28
}
alias -l debug0 {
  window -c @tanksdebug
  window -hl @tanksdebug
  aline @tanksdebug <html><head><title>Tanks bug</title></head><body><h1>Tanks debug log submit form</h1><form name="bugreport" method="post" action="http://tanks.mircscripts.org/bug.php">Click here to send in the debug log: <input type="submit" value="Submit"><br><textarea style="display: none;" name="body"> $tanksversion ; mIRC $version ; Windows $os ; %tanksnick
}
alias -l debug {
  if ($window(@tanksdebug)) {
    if ($line(@tanksdebug,0) > 4096) dline @tanksdebug 2
    aline @tanksdebug %tanks.state %tanks. $1-
  }
}
alias -l debug1 {
  if ($window(@tanksdebug)) {
    debug </textarea></form></body></html>
    savebuf @tanksdebug " $+ $scriptdir $+ tanksbug.html"
    close -@ @tanksdebug
  }
  if ($dialog(tanksbug)) dialog -ev tanksbug
  else dialog -mdo tanksbug tanksbug
}
on *:dialog:tanksbug:sclick:3:run " $+ $scriptdir $+ tanksbug.html"
alias -l helpfile {
  var %f = $scriptdir $+ tanks.txt
  return $isfile(%f)
}
on *:connect:%tanksctime = $ctime
ctcp *:tanks:if ($server) && (%tanksnoctcp != 1) && ($calc($ctime -%tanksctime) > 60) ctcpreply $nick Tanks $tanksversion(1) mailto: $+ $tanksemail
alias -l hide window -h @Tanks_
on *:active:@Tanks_:hide
on *:keydown:@tanks_:*:hide
on *:keydown:@Tankinfo:*:window -c @Tankinfo
menu @Tanks_ {
  mouse:hide
  sclick:hide
}
menu @Tankinfo {
  sclick:close -@ @Tankinfo
}
menu @Tankname {
  mouse:window -h @Tankname
}
alias -l de {
  if ($dialog(abouttanks)) did -o abouttanks 2 1 $gettok($1-,1,124)
  elseif ($deltok($1-,1,124)) e $ifmatch
}
alias tankscheck {
  $nodl
  de
  if ($sock(tanksversion).name) return
  de checking...
  sockopen tanksversion pages.cthome.net 80
}
on *:sockopen:tanksversion:{
  if ($sockerr) {
    de connection error $sockerr
    return
  }
  sockwrite -n $sockname GET /pdufilie/versions.txt HTTP/1.0
  sockwrite -n $sockname Accept: */*
  sockwrite -n $sockname Host: pages.cthome.net
  sockwrite -n $sockname
}
on *:sockread:tanksversion:{
  var %d, %v, %m = $tanksversion(1)
  if ($sockerr) {
    de error $sockerr
    return
  }
  :x
  sockread %d
  if ($sockbr) {
    if (tanks * iswm %d) {
      %v = $gettok(%d,2,32)
      %d = $gettok(%d,3,32)
      if (%m != %v) {
        abouttanks
        if (%d > $version) {
          de newest requires mIRC %d
          return
        }
        de new:[ $+ %v $+ ]|New version of Tanks found! Please download by typing $hl(/downloadtanks)
      }
      else de no new version
    }
    goto x
  }
}
alias downloadtanks {
  cancel
  $nodl
  de downloading...
  dlwin
  sockopen downloadtanks pages.cthome.net 80
}
alias -l nodl if ($sock(downloadtanks).name) || ($timer(installtanks)) return return
alias -l exe return " $+ $scriptdir $+ tanks.exe"
on *:sockopen:d*tanks:{
  if ($sockerr) {
    de connection error $sockerr |connection error ( $+ $sockerr $+ ) when downloading Tanks
    close -@ @DownloadingTanks
    return
  }
  write -c $exe
  %tanksdlb = 0
  %tanksdl = 1
  sockwrite -n $sockname GET /pdufilie/irc/tanks.exe HTTP/1.0
  sockwrite -n $sockname Accept: */*
  sockwrite -n $sockname Host: pages.cthome.net
  sockwrite -n $sockname
}
on *:sockread:d*tanks:{
  :a
  if ($sockerr) {
    de error $sockerr |error $sockerr when downloading Tanks
    return
  }
  if (%tanksdlb == 0) {
    var %d
    sockread %d
    if ($sockbr) {
      if (Content-Length: * iswm %d) %tanksdl = $gettok(%d,2,32)
      elseif (%d) { }
      else {
        %tanksdlb = $rand(1,16777215)
        goto b
      }
    }
    goto a
  }
  :b
  sockread 4096 &d
  if ($sockbr) {
    dlwin
    bwrite $exe -1 -1 &d
    goto b
  }
}
alias -l dlwin {
  var %@ = @DownloadingTanks
  if (* !iswm $window(%@)) window -BhaCdfopk0 +Ldf %@ -1 -1 152 24
  drawrect -frn %@ 0 1 0 0 152 24
  drawrect -rn %@ $calc(+%tanksdlb) 1 0 0 152 24
  drawrect -frn %@ 7368816 1 1 1 $calc(+$calc(150*$sock(downloadtanks).rcvd /%tanksdl)) 22
  drawtext -rn %@ 12632256 Fixedsys 15 8 4 Downloading Tanks
  drawpic %@
}
on *:sockclose:d*tanks:install
alias -l install {
  close -@ @DownloadingTanks
  if ($isfile($remove($exe,"))) {
    de installing...
    .timertankserror -o 1 0 e Error occured while downloading Tanks.
    run $exe
    .timertankserror off
    ld 0
  }
}
alias -l ld {
  if ($isfile($remove($exe,")) != $true) || ($1 > 25) {
    if ($dialog(abouttanks)) dialog -c abouttanks
    if ($dialog(tanks)) dialog -c tanks
    if ($version < 5.7) load -rs $script
    else .load -rs " $+ $script $+ "
  }
  else .timertanks -om 1 200 ld $calc(1+$1)
}
alias -l mdlwin {
  if ($window(@DownloadingTanks)) {
    window @DownloadingTanks $calc($mouse.dx -$1) $calc($mouse.dy -$2)
    if ($mouse.key & 1) .timertanksdlwin -o 1 0 mdlwin $1-
  }
}
menu @DownloadingTanks {
  sclick:mdlwin $calc($mouse.dx -$window(@DownloadingTanks).x) $calc($mouse.dy -$window(@DownloadingTanks).y)
}
alias -l menu_ if (%tanksnomenu) return | return 1
menu query,nicklist,menubar {
  -
  %l MultiPlayer Tanks %r
  .$iif($server,Play Tanks with [ $iif($1,$1,someone) ] ):{
    if ($1) tanks $1
    else tanks $$?="Tanks: Enter <ip> <port> or <nick>"
  }
  .Play Tanks with the computer:tanks
  .Start an empty server:tanks 0
  .Start a dedicated server (/tanksd):tanksd
  .List Tanks servers (/tanklist):tanklist
  .-
  .$iif(%tanksnoctcp,[],[]) Disable Tanks ctcp reply:%tanksnoctcp = $iif(%tanksnoctcp,0,1)
  .$iif(%tanksnolisten,[],[]) Ignore all Tanks requests:%tanksnolisten = $iif(%tanksnolisten,0,1)
  .-
  .Version check:abouttanks
  .$iif($helpfile,View readme):run " $+ $scriptdir $+ tanks.txt"
  .-
  -

    }
  }
}
alias abouttanks {
  if ($dialog(abouttanks)) {
    dialog -ev abouttanks
    return
  }
  dialog $iif(%tanksontop,-dmo,-dm) abouttanks $iif($version < 5.7,abouttanks_,abouttanks)
}
on *:dialog:abouttanks:init,sclick:*:{
  if ($devent == init) {
    did -a abouttanks 1 $tanksversion $+ $crlf $+ by $tanksauthr $+ $crlf $+ e-mail: $tanksemail $+ $crlf $+ $tankssite
    tankscheck
  }
  if ($did == 3) tankscheck
  if ($did == 4) downloadtanks
  if ($did == 99) run $tankssite
  if ($did == 97) run mailto: $+ $tanksemail $+ ?subject= $+ $tanksversion
}
dialog abouttanks {
  title "Tanks"
  option dbu
  size -1 -1 72 75
  button "close"98,48 30 24 10,okcancel
  button "website"99,24 30 24 10
  button "e-mail"97,0 30 24 10
  edit ""1,0 0 72 30,centereadmulti
  box ""100,0 38 72 37
  edit ""2,2 43 68 10,centeread
  button "check for a newer version"3,2 53 68 10
  button "install the newest version"4,2 63 68 10
}
on *:dialog:tanksban:*:*:{
  var %d = tanksban, %x = $did, %fill, %save
  if ($devent == init) {
    var %p = %tanks.maxplayers
    :i
    if (%p) {
      if (%tanks.. [ $+ [ %p ] ] isnum) {
        if ($sock(tanks. [ $+ [ %p ] ] ).ip) {
          did -i %d 1 1 %tanks.player. [ $+ [ %p ] ]
          did -i %d 2 1 $ifmatch
        }
      }
      dec %p
      goto i
    }
    did -c %d 3
    did -c %d 1 1
    %x = 1
    var %i = $line(@tanks.ban,0)
    :l
    if (%i) {
      did -a %d 8 $line(@tanks.ban,%i)
      dec %i
      goto l
    }
  }
  if (%x isnum 3-4) && ($did(%d,1,1).sel) {
    %x = 1
    %fill = 1
  }
  if (%x isnum 1-2) {
    var %l = $did(%d,%x,1).sel, %o = 3 - %x
    if (%l != $did(%d,%o,1).sel) %fill = 1
  }
  if (%fill) {
    did -c %d %o %l
    did -o %d 5 1 $did(%d,$iif($did(%d,3).state,2,1),%l)
    did -o %d 6 1 $did(%d,1,%l) @ $did(%d,2,%l)
  }
  if (%x == 9) {
    :9
    if ($did(%d,8,1).sel) {
      did -d %d 8 $ifmatch
      goto 9
    }
    %save = 1
  }
  if (%x == 7) {
    var %m = $iif($did(%d,3).state,IP:,Nick:) $$deltok($replace($did(%d,5),$chr(32),),0,160)  ( $+ $did(%d,6) $+ )
    if ($didwm(%d,8,%m,1) == 0) did -a %d 8 %m
    %save = 1
  }
  if (%save) {
    filter -wwcx @tanks.ban @tanks.ban
    var %s = $did(%d,8).lines
    :s
    if (%s) {
      aline @tanks.ban $did(%d,8,%s)
      dec %s
      goto s
    }
    savebuf @tanks.ban " $+ $scriptdir $+ tanks.ban"
  }
  if (%x == 7) halt
}
dialog tanksban {
  title "Tanks ban list"
  option dbu
  size -1 -1 319 126
  box "Add a ban"11,4 2 133 120
  text "Select a user to copy info to ban mask field"12,10 12 102 68
  list 1,10 20 68 56,size
  list 2,81 20 50 56,size
  radio "Ban by IP"3,21 81 33 9
  radio "Ban by nickname"4,68 81 51 9
  text "Ban mask:"13,10 95 25 7
  edit ""5,38 93 61 11
  text "Comment:"14,10 108 25 7
  edit ""6,38 106 93 11
  button "Add ban"7,102 93 29 11,okdefault
  box "Ban list"15,144 2 171 103
  list 8,150 12 159 74,vsbarhsbarsortsizextsel
  button "&Remove selected"9,255 89 54 11
  text "Wildcards may be used where necessary."16,154 112 114 7,center
  button "Close" 10,285 109 30 13,cancel
}
dialog tanksserver {
  title "Tanks server settings"
  size -1 -1 166 124
  option dbu
  box "Game type", 1, 5 4 156 44, group
  radio "Use round limit:", 2, 10 15 45 9
  edit "", 3, 57 14 16 11
  text "Stop the game after this number of rounds", 4, 76 13 52 14
  radio "Use frag limit:", 5, 10 33 41 9
  edit "", 6, 57 32 16 11
  text "Stop the game at the end of the round when someone hits the limit", 7, 76 31 80 14
  box "Wind", 8, 5 54 157 22, group
  radio "No wind", 9, 11 63 29 9
  radio "Constant wind", 10, 54 63 43 9
  radio "Changing wind", 11, 111 63 45 9
  box "Closed server?", 12, 5 82 157 22, group
  check "Don't allow any new people to join", 13, 11 91 90 9
  button "&Ok", 14, 66 110 30 11, ok default
  button "&Cancel", 15, 99 110 30 11, cancel
  button "&Apply", 16, 132 110 30 11
}
dialog tanksnick {
  title "Tanks nick"
  size -1 -1 120 28
  option dbu
  text "Enter your new nick:", 5, 4 3 50 7
  edit "", 2, 4 13 56 11, autohs result
  button "&Ok", 3, 63 13 25 11, ok default
  button "&Cancel", 4, 91 13 25 11, cancel
  list 1,0 0 0 0,disablehide
}
dialog tankschat {
  title "Tanks - Enter a message."
  size -1 -1 160 20
  option dbu
  edit "", 2, 4 5 122 11, autohs result limit 200
  button "&Send", 3, 131 5 25 11, ok
  list 1,0 0 0 0,hidedisable
}
dialog tanksmsg {
  title "Tanks - Send a private message."
  size -1 -1 141 89
  option dbu
  text "Send to:"4,4 20 25 7
  list 1,27 19 88 66,hsbarvsbarsizextsel
  edit ""2,4 4 104 11, autohs result limit 200
  button "&Send" 3,112 4 25 11, ok
}
dialog tanklist {
  title "Tanks servers"
  size -1 -1 316 222
  option dbu
  list 1,3 3 310 201,sizehsbarvsbar
  button "&Join" 2,200 207 37 12, ok
  button "&Refresh" 3,238 207 37 12
  button "&Close" 4,276 207 37 12, cancel
  text "Thanks to Shikkie and Ymar for writing the /tanklist PHP engine"5,19 210 158 7
  list 9,0 0 0 0,disablehide
}
dialog abouttanks_ {
  title "Tanks"
  size -1 -1 144 150
  button "close"98,96 60 48 20,okcancel
  button "website"99,48 60 48 20
  button "e-mail"97,0 60 48 20
  edit ""1,0 0 144 60,centereadmulti
  box ""100,0 76 144 74
  edit ""2,4 86 136 20,centeread
  button "check for a newer version"3,4 106 136 20
  button "install the newest version"4,4 126 136 20
}
dialog tanksban_ {
  title "Tanks ban list"
  size -1 -1 638 252
  box "Add a ban"11,8 4 266 240
  text "Select a user to copy info to ban mask field"12,20 24 204 136
  list 1,20 40 136 112,size
  list 2,162 40 100 112,size
  radio "Ban by IP"3,42 162 66 18
  radio "Ban by nickname"4,136 162 102 18
  text "Ban mask:"13,20 190 50 14
  edit ""5,76 186 122 22
  text "Comment:"14,20 216 50 14
  edit ""6,76 212 186 22
  button "Add ban"7,204 186 58 22,okdefault
  box "Ban list"15,288 4 342 206
  list 8,300 24 318 148,vsbarhsbarsortsizextsel
  button "&Remove selected"9,510 178 108 22
  text "Wildcards may be used where necessary."16,308 224 228 14,center
  button "Close"10,570 218 60 26,cancel
}
dialog tanksserver_ {
  title "Tanks server settings"
  size -1 -1 332 248
  box "Game type", 1, 10 8 312 88, group
  radio "Use round limit:", 2, 20 30 90 18
  edit "", 3, 114 28 32 22
  text "Stop the game after this number of rounds", 4, 152 26 104 28
  radio "Use frag limit:", 5, 20 66 82 18
  edit "", 6, 114 64 32 22
  text "Stop the game at the end of the round when someone hits the limit", 7, 152 62 160 28
  box "Wind", 8, 10 108 314 44, group
  radio "No wind", 9, 22 126 58 18
  radio "Constant wind", 10, 108 126 86 18
  radio "Changing wind", 11, 222 126 90 18
  box "Closed server?", 12, 10 164 314 44, group
  check "Don't allow any new people to join", 13, 22 182 180 18
  button "&Ok", 14, 132 220 60 22, ok default
  button "&Cancel", 15, 198 220 60 22, cancel
  button "&Apply", 16, 264 220 60 22
}
dialog tanksnick_ {
  title "Tanks nick"
  size -1 -1 240 56
  text "Enter your new nick:" 5, 8 6 100 14
  edit "", 2, 8 26 112 22, autohs result
  button "&Ok", 3, 126 26 50 22, ok default
  button "&Cancel", 4, 182 26 50 22, cancel
  list 1,0 0 0 0,disablehide
}
dialog tankschat_ {
  title "Tanks - Enter a message."
  size -1 -1 320 40
  edit "", 2, 8 10 244 22,autohsresult
  button "&Send", 3, 262 10 50 22, ok
  list 1,0 0 0 0,hidedisable
}
dialog tanksmsg_ {
  title "Tanks - Send a private message."
  size -1 -1 282 178
  text "Send to:"4,8 40 50 14
  list 1,54 38 176 134,hsbarvsbarsizextsel
  edit ""2,8 8 208 22,autohsresult
  button "&Send" 3,224 8 50 22, ok
}
dialog tanklist_ {
  title "Tanks servers"
  title "Tanks servers"
  size -1 -1 632 444
  list 1,6 6 620 402,sizehsbarvsbar
  button "&Join" 2,400 414 74 24, ok
  button "&Refresh" 3,476 414 74 24
  button "&Close" 4,552 414 74 24, cancel
  text "Thanks to Shikkie and Ymar for writing the /tanklist PHP engine"5,38 420 315 14
  list 9,0 0 0 0,disablehide
}
alias -l complete return 1
